/* CHRCUR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int chrcur_(ve, vm, ap, bp, n, radb, slant, akp, akf, alinc, 
	lunit)
complex *ve, *vm, *ap, *bp;
integer *n;
real *radb, *slant, *akp, *akf, *alinc;
integer *lunit;
{
    /* Initialized data */

    static real pi = (float)3.141592654;
    static complex cj = {(float)0.,(float)1.};
    static real zz = (float)376.73;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8, q__9, q__10, 
	    q__11, q__12, q__13;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    double sqrt(), cos(), sin(), c_abs();
    integer s_wdue(), do_uio(), e_wdue(), s_rdue(), e_rdue();

    /* Local variables */
#define frec ((real *)equiv_2)
    static integer krec;
#define ibuf ((integer *)equiv_0)
    static complex quad;
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static real curn;
    static integer i__, j;
    static real s, power, r1, r2, bj, dp;
    static complex ep;
    static real dr;
    static complex er, hp, hr;
#define pk (equiv_0 + 2)
    static real ph;
    static integer np, nn, nr;
    extern doublereal bessjn_(), besjpr_();
    static real rad, bjp;
    static complex phi;
    static real akz;
    static complex psi;

    /* Fortran I/O blocks */
    static cilist io___32 = { 0, 0, 0, 0, 0 };
    static cilist io___35 = { 0, 0, 0, 0, 0 };
    static cilist io___36 = { 0, 0, 0, 0, 0 };
    static cilist io___37 = { 0, 0, 0, 0, 1 };



/*  Currents File of Circular Corrugated Waveguide Horn */

/*  VE      Voltage magnitude of TE component */
/*  VM      Voltage magnitude of TM component */
/*          VM/VE = Hybrid mode ratio */
/*          If VM = 0, TE mode horn */
/*          If VE = 0, TM mode horn */
/*  AP      Amplitude of cosinusoidal circumferentially-varying field */
/*  BP      Amplitude of sinusoidal circumferentially-varying field */
/*  N       Order of circumferentially-varying field */
/*  RADB    Outer radius (m) */
/*  SLANT   Slant radius of horn */
/*  AKP     Radial component propagation constant */
/*  AKF     Propagation constant in free space */
/*  ALINC   Length increment for current patches */
/*  NR      Number of points in radial integrals */
/*  NP      Number of points in Phi integrals */
/*  LUNIT   Logical unit of random access file for currents */

/* Computing 2nd power */
    r__1 = *akf;
/* Computing 2nd power */
    r__2 = *akp;
    akz = r__1 * r__1 - r__2 * r__2;
/* ------------- Check for cutoff */
    if (akz <= (float)0.) {
	return 0;
    }
    akz = sqrt(akz);
    curj[2].r = (float)0., curj[2].i = (float)0.;
    curm[2].r = (float)0., curm[2].i = (float)0.;
    power = (float)0.;
    nr = *radb / *alinc + (float).5;
    dr = *radb / nr;
    frec[2] = (float)0.;
    *pk = *akf;
    krec = 1;
/* ------------- Loop over radius */
    i__1 = nr;
    for (j = 1; j <= i__1; ++j) {
	rad = ((real) (j - 1) + (float).5) * dr;
	r__1 = rad * *akp;
	bj = bessjn_(n, &r__1);
	r__1 = rad * *akp;
	bjp = besjpr_(n, &r__1);
/* ------------- Find differential area */
	r1 = rad - dr / (float)2.;
	r2 = rad + dr / (float)2.;
/* ------------- Quadratic phase factor */
/* Computing 2nd power */
	r__1 = rad;
	s = *akf * (r__1 * r__1) / *slant / (float)2.;
	r__1 = cos(s);
	r__2 = -sin(s);
	q__1.r = r__1, q__1.i = r__2;
	quad.r = q__1.r, quad.i = q__1.i;
/* ------------- Loop over Phi */
	np = pi * (float)2. * rad / *alinc + (float).5;
	dp = pi * (float)2. / np;
	i__2 = np;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    ph = (real) (i__ - 1) * dp;
/* ------------- Circumferential variation */
	    r__1 = cos(*n * ph);
	    q__2.r = r__1 * ap->r, q__2.i = r__1 * ap->i;
	    r__2 = sin(*n * ph);
	    q__3.r = r__2 * bp->r, q__3.i = r__2 * bp->i;
	    q__1.r = q__2.r + q__3.r, q__1.i = q__2.i + q__3.i;
	    psi.r = q__1.r, psi.i = q__1.i;
	    r__1 = cos(*n * ph);
	    q__2.r = r__1 * bp->r, q__2.i = r__1 * bp->i;
	    r__2 = sin(*n * ph);
	    q__3.r = r__2 * ap->r, q__3.i = r__2 * ap->i;
	    q__1.r = q__2.r - q__3.r, q__1.i = q__2.i - q__3.i;
	    phi.r = q__1.r, phi.i = q__1.i;
/* ------------- Rho and Phi components */
	    q__6.r = -cj.r, q__6.i = -cj.i;
	    q__5.r = zz * q__6.r, q__5.i = zz * q__6.i;
	    q__4.r = q__5.r * psi.r - q__5.i * psi.i, q__4.i = q__5.r * psi.i 
		    + q__5.i * psi.r;
	    r__1 = akz * bjp;
	    q__8.r = r__1 * vm->r, q__8.i = r__1 * vm->i;
	    r__2 = *akf * *n * bj;
	    q__11.r = r__2 * ve->r, q__11.i = r__2 * ve->i;
	    q__10.r = q__11.r / rad, q__10.i = q__11.i / rad;
	    q__9.r = q__10.r / *akp, q__9.i = q__10.i / *akp;
	    q__7.r = q__8.r + q__9.r, q__7.i = q__8.i + q__9.i;
	    q__3.r = q__4.r * q__7.r - q__4.i * q__7.i, q__3.i = q__4.r * 
		    q__7.i + q__4.i * q__7.r;
	    q__2.r = q__3.r / *akp, q__2.i = q__3.i / *akp;
	    q__1.r = q__2.r * quad.r - q__2.i * quad.i, q__1.i = q__2.r * 
		    quad.i + q__2.i * quad.r;
	    er.r = q__1.r, er.i = q__1.i;
	    q__6.r = -cj.r, q__6.i = -cj.i;
	    q__5.r = zz * q__6.r, q__5.i = zz * q__6.i;
	    q__4.r = q__5.r * phi.r - q__5.i * phi.i, q__4.i = q__5.r * phi.i 
		    + q__5.i * phi.r;
	    r__1 = akz * *n;
	    q__11.r = r__1 * vm->r, q__11.i = r__1 * vm->i;
	    q__10.r = bj * q__11.r, q__10.i = bj * q__11.i;
	    q__9.r = q__10.r / rad, q__9.i = q__10.i / rad;
	    q__8.r = q__9.r / *akp, q__8.i = q__9.i / *akp;
	    q__13.r = *akf * ve->r, q__13.i = *akf * ve->i;
	    q__12.r = bjp * q__13.r, q__12.i = bjp * q__13.i;
	    q__7.r = q__8.r + q__12.r, q__7.i = q__8.i + q__12.i;
	    q__3.r = q__4.r * q__7.r - q__4.i * q__7.i, q__3.i = q__4.r * 
		    q__7.i + q__4.i * q__7.r;
	    q__2.r = q__3.r / *akp, q__2.i = q__3.i / *akp;
	    q__1.r = q__2.r * quad.r - q__2.i * quad.i, q__1.i = q__2.r * 
		    quad.i + q__2.i * quad.r;
	    ep.r = q__1.r, ep.i = q__1.i;
	    q__4.r = cj.r * phi.r - cj.i * phi.i, q__4.i = cj.r * phi.i + 
		    cj.i * phi.r;
	    r__1 = *akf * *n;
	    q__9.r = r__1 * vm->r, q__9.i = r__1 * vm->i;
	    q__8.r = bj * q__9.r, q__8.i = bj * q__9.i;
	    q__7.r = q__8.r / rad, q__7.i = q__8.i / rad;
	    q__6.r = q__7.r / *akp, q__6.i = q__7.i / *akp;
	    q__11.r = akz * ve->r, q__11.i = akz * ve->i;
	    q__10.r = bjp * q__11.r, q__10.i = bjp * q__11.i;
	    q__5.r = q__6.r + q__10.r, q__5.i = q__6.i + q__10.i;
	    q__3.r = q__4.r * q__5.r - q__4.i * q__5.i, q__3.i = q__4.r * 
		    q__5.i + q__4.i * q__5.r;
	    q__2.r = q__3.r / *akp, q__2.i = q__3.i / *akp;
	    q__1.r = q__2.r * quad.r - q__2.i * quad.i, q__1.i = q__2.r * 
		    quad.i + q__2.i * quad.r;
	    hr.r = q__1.r, hr.i = q__1.i;
	    q__5.r = -cj.r, q__5.i = -cj.i;
	    q__4.r = q__5.r * psi.r - q__5.i * psi.i, q__4.i = q__5.r * psi.i 
		    + q__5.i * psi.r;
	    r__1 = *akf * bjp;
	    q__7.r = r__1 * vm->r, q__7.i = r__1 * vm->i;
	    r__2 = akz * *n * bj;
	    q__10.r = r__2 * ve->r, q__10.i = r__2 * ve->i;
	    q__9.r = q__10.r / rad, q__9.i = q__10.i / rad;
	    q__8.r = q__9.r / *akp, q__8.i = q__9.i / *akp;
	    q__6.r = q__7.r + q__8.r, q__6.i = q__7.i + q__8.i;
	    q__3.r = q__4.r * q__6.r - q__4.i * q__6.i, q__3.i = q__4.r * 
		    q__6.i + q__4.i * q__6.r;
	    q__2.r = q__3.r / *akp, q__2.i = q__3.i / *akp;
	    q__1.r = q__2.r * quad.r - q__2.i * quad.i, q__1.i = q__2.r * 
		    quad.i + q__2.i * quad.r;
	    hp.r = q__1.r, hp.i = q__1.i;
/* ------------- Differential area and position */
/* Computing 2nd power */
	    r__1 = r2;
/* Computing 2nd power */
	    r__2 = r1;
	    frec[3] = dp * (r__1 * r__1 - r__2 * r__2) / (float)2.;
	    frec[0] = rad * cos(ph);
	    frec[1] = rad * sin(ph);
/* ------------- Normalized magnetic and electric currents * Area 
*/
	    r__1 = sin(ph);
	    q__4.r = r__1 * hr.r, q__4.i = r__1 * hr.i;
	    r__2 = cos(ph);
	    q__5.r = r__2 * hp.r, q__5.i = r__2 * hp.i;
	    q__3.r = q__4.r + q__5.r, q__3.i = q__4.i + q__5.i;
	    q__2.r = -q__3.r, q__2.i = -q__3.i;
	    q__1.r = frec[3] * q__2.r, q__1.i = frec[3] * q__2.i;
	    curj[0].r = q__1.r, curj[0].i = q__1.i;
	    r__1 = cos(ph);
	    q__3.r = r__1 * hr.r, q__3.i = r__1 * hr.i;
	    r__2 = sin(ph);
	    q__4.r = r__2 * hp.r, q__4.i = r__2 * hp.i;
	    q__2.r = q__3.r - q__4.r, q__2.i = q__3.i - q__4.i;
	    q__1.r = frec[3] * q__2.r, q__1.i = frec[3] * q__2.i;
	    curj[1].r = q__1.r, curj[1].i = q__1.i;
	    r__1 = sin(ph);
	    q__3.r = r__1 * er.r, q__3.i = r__1 * er.i;
	    r__2 = cos(ph);
	    q__4.r = r__2 * ep.r, q__4.i = r__2 * ep.i;
	    q__2.r = q__3.r + q__4.r, q__2.i = q__3.i + q__4.i;
	    q__1.r = frec[3] * q__2.r, q__1.i = frec[3] * q__2.i;
	    curm[0].r = q__1.r, curm[0].i = q__1.i;
	    r__1 = cos(ph);
	    q__4.r = r__1 * er.r, q__4.i = r__1 * er.i;
	    r__2 = sin(ph);
	    q__5.r = r__2 * ep.r, q__5.i = r__2 * ep.i;
	    q__3.r = q__4.r - q__5.r, q__3.i = q__4.i - q__5.i;
	    q__2.r = -q__3.r, q__2.i = -q__3.i;
	    q__1.r = frec[3] * q__2.r, q__1.i = frec[3] * q__2.i;
	    curm[1].r = q__1.r, curm[1].i = q__1.i;
/* ------------- Normalized aperture power * Area */
	    q__1.r = curm[1].r * curj[0].r - curm[1].i * curj[0].i, q__1.i = 
		    curm[1].r * curj[0].i + curm[1].i * curj[0].r;
	    q__2.r = curm[0].r * curj[1].r - curm[0].i * curj[1].i, q__2.i = 
		    curm[0].r * curj[1].i + curm[0].i * curj[1].r;
	    power += (c_abs(&q__1) + c_abs(&q__2)) / frec[3];
	    ++krec;
/* L1: */
	    io___32.ciunit = *lunit;
	    io___32.cirec = krec;
	    s_wdue(&io___32);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
	}
/* L2: */
    }
    curn = sqrt(power);
/* ------------- Normalize aperture power to 1 watt */
    i__1 = krec;
    for (i__ = 2; i__ <= i__1; ++i__) {
	io___35.ciunit = *lunit;
	io___35.cirec = i__;
	s_rdue(&io___35);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	q__1.r = curm[0].r / curn, q__1.i = curm[0].i / curn;
	curm[0].r = q__1.r, curm[0].i = q__1.i;
	q__1.r = curm[1].r / curn, q__1.i = curm[1].i / curn;
	curm[1].r = q__1.r, curm[1].i = q__1.i;
	q__1.r = curj[0].r / curn, q__1.i = curj[0].i / curn;
	curj[0].r = q__1.r, curj[0].i = q__1.i;
	q__1.r = curj[1].r / curn, q__1.i = curj[1].i / curn;
	curj[1].r = q__1.r, curj[1].i = q__1.i;
/* L3: */
	io___36.ciunit = *lunit;
	io___36.cirec = i__;
	s_wdue(&io___36);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
    ibuf[0] = krec - 1;
    ibuf[1] = 0;
    io___37.ciunit = *lunit;
    s_wdue(&io___37);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* chrcur_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


