/* CURROT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Table of constant values */

static integer c__1 = 1;
static integer c__3 = 3;

/* Subroutine */ int currot_(rot, cent)
real *rot, *cent;
{
    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Local variables */
    static integer j, k;
    static complex curji[3], curmi[3], curjo[3], curmo[3];
    static real xa[3], xc[3];
    extern /* Subroutine */ int cvtrot_(), mtmult_();


/*  Rotation of Currents in Common about point in space */

/*  ROT(3,3)   Rotation matrix */
/*  CENT(3)    Center of rotation */


/*  CURRENT Common */

/*  NCUR     Number of points */
/*  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only */
/*  PKC      Propagation constant (1./meters) */
/*  POSC     Position of current element (meters) */
/*  CURJA    Electric current * area rectangular components (complex) */
/*  CURMA    Magnetic current * area rectangular components (complex) */

    /* Parameter adjustments */
    --cent;
    rot -= 4;

    /* Function Body */
    i__1 = currenp_1.ncur;
    for (k = 1; k <= i__1; ++k) {
	for (j = 1; j <= 3; ++j) {
	    xc[j - 1] = currenp_1.posc[j + k * 3 - 4] - cent[j];
	    i__2 = j - 1;
	    i__3 = j + k * 3 - 4;
	    curji[i__2].r = currenj_1.curja[i__3].r, curji[i__2].i = 
		    currenj_1.curja[i__3].i;
/* L1: */
	    i__2 = j - 1;
	    i__3 = j + k * 3 - 4;
	    curmi[i__2].r = currenm_1.curma[i__3].r, curmi[i__2].i = 
		    currenm_1.curma[i__3].i;
	}
	mtmult_(xc, &rot[4], xa, &c__1, &c__3, &c__3);
	cvtrot_(curji, &rot[4], curjo);
	cvtrot_(curmi, &rot[4], curmo);
	for (j = 1; j <= 3; ++j) {
	    currenp_1.posc[j + k * 3 - 4] = xa[j - 1] + cent[j];
	    i__2 = j + k * 3 - 4;
	    i__3 = j - 1;
	    currenj_1.curja[i__2].r = curjo[i__3].r, currenj_1.curja[i__2].i =
		     curjo[i__3].i;
/* L2: */
	    i__2 = j + k * 3 - 4;
	    i__3 = j - 1;
	    currenm_1.curma[i__2].r = curmo[i__3].r, currenm_1.curma[i__2].i =
		     curmo[i__3].i;
	}
/* L3: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* currot_ */

