/* ELLBLN.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float)-1.;
static real c_b3 = (float)1.;

doublereal ellbln_(xb, xs, xf)
real *xb, *xs, *xf;
{
    /* System generated locals */
    real ret_val, r__1, r__2;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer i__;
    static real p[3], t, v, y[3];
    extern /* Subroutine */ int vlinc_(), cross_(), pints_();
    static real fs[3], rv[3], fsl;
    extern doublereal dot_();
    static integer nis;


/*  Elliptical Disk Blockage function for near field */

/*  XB(1)   X position of disk center */
/*    (2)   Y position of disk center */
/*    (3)   Z position of disk center */
/*    (4)   Major Axis Radius */
/*    (5)   Minor Axis Radius */
/*    (6)   Unit normal to disk (X component) */
/*    (7)   Unit normal to disk (Y component) */
/*    (8)   Unit normal to disk (Z component) */
/*    (9)   Unit vector from center along major axis (X component) */
/*    (10)  Unit vector from center along major axis (Y component) */
/*    (11)  Unit vector from center along major axis (Z component) */
/*  XS      Source point */
/*  XF      Field point */

    /* Parameter adjustments */
    --xf;
    --xs;
    --xb;

    /* Function Body */
    ret_val = (float)0.;
    vlinc_(&c_b2, &xs[1], &c_b3, &xf[1], fs);
    fsl = sqrt(dot_(fs, fs));
    for (i__ = 1; i__ <= 3; ++i__) {
/* L1: */
	fs[i__ - 1] /= fsl;
    }
    pints_(&xs[1], fs, &xb[1], &xb[7], &t, p, &nis);
    if (nis == -1) {
	return ret_val;
    }
    cross_(&xb[6], &xb[9], y);
    vlinc_(&c_b3, p, &c_b2, &xb[1], rv);
/* Computing 2nd power */
    r__1 = dot_(rv, &xb[9]) / xb[4];
/* Computing 2nd power */
    r__2 = dot_(rv, y) / xb[5];
    v = r__1 * r__1 + r__2 * r__2 - (float)1.;
    if (v <= (float)0.) {
	ret_val = (float)1.;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* ellbln_ */

