/* FFPATR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Subroutine */ int ffpatr_(xc, block, xb, theta, phi, etheta, ephi)
real *xc;
doublereal (*block) ();
real *xb, *theta, *phi;
complex *etheta, *ephi;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1;
    complex q__1, q__2;

    /* Local variables */
    static complex conj, curj[3], curm[3];
    static integer i__, j;
    extern /* Subroutine */ int ffdirc_();
    static real vp[3], vr[3], vt[3], xs[3];
    extern /* Subroutine */ int vgrejf_(), vgrhjf_();
    static complex eph, eth;


/*  Far field pattern from currents in common */

/*  XC(3)     Position of center of currents */
/*  BLOCK     Blockage function (external) = 1 when blocked */
/*  XB        Array of variables for blockage function */
/*  THETA     Angle from Z axis (boresight) (radians) */
/*  PHI       Spherical angle from X-axis (radians) */
/*  ETHETA    Electric field in Theta direction */
/*  EPHI      Electric field in Phi direction */


/*  CURRENT Common */

/*  NCUR     Number of points */
/*  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only */
/*  PKC      Propagation constant (1/meters) */
/*  POSC     Position of current element (meters) */
/*  CURJA    Electric current * area rectangular components (complex) */
/*  CURMA    Magnetic current * area rectangular components (complex) */

    /* Parameter adjustments */
    --xb;
    --xc;

    /* Function Body */
    ffdirc_(theta, phi, vr, vt, vp);
/* ------------- -j*2*Pi*Frequency*Mu */
    r__1 = -currenp_1.pkc * cc * (float)400. * pi;
    q__1.r = (float)0., q__1.i = r__1;
    conj.r = q__1.r, conj.i = q__1.i;
    etheta->r = (float)0., etheta->i = (float)0.;
    ephi->r = (float)0., ephi->i = (float)0.;
    i__1 = currenp_1.ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	for (j = 1; j <= 3; ++j) {
	    xs[j - 1] = currenp_1.posc[j + i__ * 3 - 4] + xc[j];
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curj[i__2].r = currenj_1.curja[i__3].r, curj[i__2].i = 
		    currenj_1.curja[i__3].i;
/* L1: */
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curm[i__2].r = currenm_1.curma[i__3].r, curm[i__2].i = 
		    currenm_1.curma[i__3].i;
	}
	if ((*block)(&xb[1], xs, vr) == (float)0.) {
	    if (currenp_1.nctyp < 2) {
/* --------- Electric currents available */
		vgrejf_(vr, vt, vp, xs, &currenp_1.pkc, curj, &eth, &eph);
		q__2.r = eth.r * conj.r - eth.i * conj.i, q__2.i = eth.r * 
			conj.i + eth.i * conj.r;
		q__1.r = etheta->r + q__2.r, q__1.i = etheta->i + q__2.i;
		etheta->r = q__1.r, etheta->i = q__1.i;
		q__2.r = eph.r * conj.r - eph.i * conj.i, q__2.i = eph.r * 
			conj.i + eph.i * conj.r;
		q__1.r = ephi->r + q__2.r, q__1.i = ephi->i + q__2.i;
		ephi->r = q__1.r, ephi->i = q__1.i;
	    }
	    if (currenp_1.nctyp != 1) {
/* --------- Magnetic currents available */
		vgrhjf_(vr, vt, vp, xs, &currenp_1.pkc, curm, &eth, &eph);
		q__1.r = etheta->r - eth.r, q__1.i = etheta->i - eth.i;
		etheta->r = q__1.r, etheta->i = q__1.i;
		q__1.r = ephi->r - eph.r, q__1.i = ephi->i - eph.i;
		ephi->r = q__1.r, ephi->i = q__1.i;
	    }
	}
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* ffpatr_ */

