/* HYBRF.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    real x[4];
} hybm_;

#define hybm_1 hybm_

doublereal hybrf_(xb)
real *xb;
{
    /* Initialized data */

    static real zz = (float)376.73;

    /* System generated locals */
    real ret_val, r__1, r__2;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer n;
    static real rp;
    extern doublereal bessjn_(), besjpr_();
    static real ajn, ajp, bkz;


/*  Hybrid Mode F function to be Zeroed to find Radial Wave Number */

/*  XB     Radial Wavenumber 1/meters */


/*  X(1)   Radius of Waveguide (meters) */
/*  X(2)   Wall Reactance (due to corrugations or dielectric slab) */
/*  X(3)   Free Space Propagation Constant 1/meters */
/*  X(4)   Circumferential mode number: n */

    n = hybm_1.x[3];
    rp = *xb * hybm_1.x[0];
    ajn = bessjn_(&n, &rp);
    ajp = besjpr_(&n, &rp);
/*  ------------- Z axis wavenumber */
/* Computing 2nd power */
    r__1 = hybm_1.x[2];
/* Computing 2nd power */
    r__2 = *xb;
    bkz = sqrt(r__1 * r__1 - r__2 * r__2);
/*  ------------- Characteristic Equation */
    ret_val = rp * hybm_1.x[2] * ajp / (bkz * n * ajn) + bkz * n * ajn / *xb /
	     rp / (zz * ajn / hybm_1.x[1] - hybm_1.x[2] * ajp / *xb);
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* hybrf_ */

