/* HYMK11.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    real xhyb[4];
} hybm_;

#define hybm_1 hybm_

/* Subroutine */ int hymk11_(radius, xs, ak0, akp)
real *radius, *xs, *ak0, *akp;
{
    /* Initialized data */

    static real xacc = (float)1e-5;

    static integer i__;
    static real x;
    extern doublereal hybrf_();
    static real aa, bb;
    extern doublereal rtflsp_();


/*  Hybrid Waveguide Mode Radial wave number for 11 mode */

/*  RADIUS   Waveguide radius */
/*  XS       Wall reactance */
/*  AK0      Free space propagation constant */
/*  AKP      Output Radial Wave Number */


/*  XHYB(1)  Waveguide Radius */
/*  XHYB(2)  Wall Reactance */
/*  XHYB(3)  Free space propagation constant */
/*  XHYB(4)  Circumferential mode number */

    hybm_1.xhyb[0] = *radius;
    hybm_1.xhyb[1] = *xs;
    hybm_1.xhyb[2] = *ak0;
    hybm_1.xhyb[3] = (float)1.;
    for (i__ = 1; i__ <= 12; ++i__) {
	x = ((float)3.2 - i__ * (float).1) / *radius;
	if (hybrf_(&x) > (float)0.) {
	    goto L2;
	}
/* L1: */
    }
L2:
    aa = ((float)3.2 - i__ * (float).1) / *radius;
    bb = ((float)3.3 - i__ * (float).1) / *radius;
/* ------ RTFLSP ref: Numerical Recipes in FORTRAN, 2nd ed. Cambridge */
/*        p. 349 */
    *akp = rtflsp_(hybrf_, &aa, &bb, &xacc);
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* hymk11_ */

