/* NRPATR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Subroutine */ int nrpatr_(xc, block, xb, xf, efield, hfield)
real *xc;
doublereal (*block) ();
real *xb, *xf;
complex *efield, *hfield;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;
    static real eps = (float).008854185;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    real r__1;
    complex q__1, q__2;

    /* Local variables */
    static complex conj, conm, curj[3], curm[3];
    static integer i__, j;
    static complex ef[3], hf[3];
    static real xs[3];
    extern /* Subroutine */ int vgrejn_(), vgrhjn_();


/*  Radiative Near field pattern from currents in common */

/*  XC(3)     Position of center of currents */
/*  BLOCK     Blockage function (external) = 1 when blocked */
/*  XB        Array of variables for blockage function */
/*  XF        Field point (meters) */
/*  EFIELD    Electric field (V/m) */
/*  HFIELD    Magnetic field */


/*  CURRENT Common */

/*  NCUR     Number of points */
/*  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only */
/*  PKC      Propagation constant (1./meters) */
/*  POSC     Position of current element (meters) */
/*  CURJA    Electric current * area rectangular components (complex) */
/*  CURMA    Magnetic current * area rectangular components (complex) */

    /* Parameter adjustments */
    --hfield;
    --efield;
    --xf;
    --xb;
    --xc;

    /* Function Body */
/* ------------- -j*2*Pi*Frequency*Mu  ------ electric field factor */
    r__1 = -currenp_1.pkc * cc * (float)400. * pi;
    q__1.r = (float)0., q__1.i = r__1;
    conj.r = q__1.r, conj.i = q__1.i;
/* ------------- -j*2*Pi*Frequency*epsilon -- magnetic field factor */
    r__1 = -currenp_1.pkc * cc * eps;
    q__1.r = (float)0., q__1.i = r__1;
    conm.r = q__1.r, conm.i = q__1.i;
    for (i__ = 1; i__ <= 3; ++i__) {
	i__1 = i__;
	efield[i__1].r = (float)0., efield[i__1].i = (float)0.;
/* L1: */
	i__1 = i__;
	hfield[i__1].r = (float)0., hfield[i__1].i = (float)0.;
    }
/* --------- Loop on current patches */
    i__1 = currenp_1.ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	for (j = 1; j <= 3; ++j) {
	    xs[j - 1] = currenp_1.posc[j + i__ * 3 - 4] + xc[j];
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curj[i__2].r = currenj_1.curja[i__3].r, curj[i__2].i = 
		    currenj_1.curja[i__3].i;
/* L2: */
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curm[i__2].r = currenm_1.curma[i__3].r, curm[i__2].i = 
		    currenm_1.curma[i__3].i;
	}
/* --------- Check for ray blockage */
	if ((*block)(&xb[1], xs, &xf[1]) == (float)0.) {
	    if (currenp_1.nctyp < 2) {
/* --------- Electric currents available */
		vgrejn_(&xf[1], xs, &currenp_1.pkc, curj, ef);
		for (j = 1; j <= 3; ++j) {
/* L3: */
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__2.r = ef[i__4].r * conj.r - ef[i__4].i * conj.i, 
			    q__2.i = ef[i__4].r * conj.i + ef[i__4].i * 
			    conj.r;
		    q__1.r = efield[i__3].r + q__2.r, q__1.i = efield[i__3].i 
			    + q__2.i;
		    efield[i__2].r = q__1.r, efield[i__2].i = q__1.i;
		}
		vgrhjn_(&xf[1], xs, &currenp_1.pkc, curj, hf);
		for (j = 1; j <= 3; ++j) {
/* L4: */
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__1.r = hfield[i__3].r + hf[i__4].r, q__1.i = hfield[
			    i__3].i + hf[i__4].i;
		    hfield[i__2].r = q__1.r, hfield[i__2].i = q__1.i;
		}
	    }
	    if (currenp_1.nctyp != 1) {
/* --------- Magnetic currents available */
		vgrejn_(&xf[1], xs, &currenp_1.pkc, curm, hf);
		for (j = 1; j <= 3; ++j) {
/* L5: */
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__2.r = hf[i__4].r * conm.r - hf[i__4].i * conm.i, 
			    q__2.i = hf[i__4].r * conm.i + hf[i__4].i * 
			    conm.r;
		    q__1.r = hfield[i__3].r + q__2.r, q__1.i = hfield[i__3].i 
			    + q__2.i;
		    hfield[i__2].r = q__1.r, hfield[i__2].i = q__1.i;
		}
		vgrhjn_(&xf[1], xs, &currenp_1.pkc, curm, ef);
		for (j = 1; j <= 3; ++j) {
/* L6: */
		    i__2 = j;
		    i__3 = j;
		    i__4 = j - 1;
		    q__1.r = efield[i__3].r - ef[i__4].r, q__1.i = efield[
			    i__3].i - ef[i__4].i;
		    efield[i__2].r = q__1.r, efield[i__2].i = q__1.i;
		}
	    }
	}
/* L7: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* nrpatr_ */

