/* PO01.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Table of constant values */

static integer c__19 = 19;
static integer c__500 = 500;
static integer c__1 = 1;

/* Main program */ MAIN__()
{
    /* Initialized data */

    static real xc[3] = { (float)0.,(float)0.,(float)0. };

    /* System generated locals */
    real r__1;
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    integer f_open();
    double c_abs(), r_lg10();
    integer f_clos();

    /* Local variables */
    static real alen, emax, axis[500];
    extern /* Subroutine */ int plot_();
    static integer npts, i__;
    static real field[500];
    static complex efield[3];
    static real xb[1];
    static complex hfield[3];
    static real xf[3];
    extern /* Subroutine */ int blockn_();
    extern /* Subroutine */ int curcom_(), nfpatr_(), lincur_();


/*  FORTRAN repeat of example: Uniform Magnetic Current for 30 wave. */


/*  CURRENT Common */

/*  NCUR     Number of points */
/*  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only */
/*  PKC      Propagation constant (1./meters) */
/*  POSC     Position of current element (meters) */
/*  CURJA    Electric current * area rectangular components (complex) */
/*  CURMA    Magnetic current * area rectangular components (complex) */

    alen = (float)30.;
    npts = 30;
/* ------- Open random access file for currents */
    o__1.oerr = 0;
    o__1.ounit = 19;
    o__1.ofnmlen = 8;
    o__1.ofnm = "PO01.DAT";
    o__1.orl = 76;
    o__1.osta = 0;
    o__1.oacc = "DIRECT";
    o__1.ofm = 0;
    o__1.oblnk = 0;
    f_open(&o__1);
/* ------- Create file with currents */
    lincur_(&alen, &npts, &c__19);
/* ------- Load currents into common */
    curcom_(&c__19);
    emax = (float)-5e3;
/* ------- Scan in plane with line source as normal */
    xf[1] = (float)0.;
    xf[2] = (float)0.;
    for (i__ = 1; i__ <= 500; ++i__) {
	axis[i__ - 1] = i__ * (float).002;
/* Computing 2nd power */
	r__1 = alen;
	xf[0] = axis[i__ - 1] * (float)2. * (r__1 * r__1);
	nfpatr_(xc, blockn_, xb, xf, efield, hfield);
	field[i__ - 1] = c_abs(&efield[1]) * xf[0];
	if (field[i__ - 1] > emax) {
	    emax = field[i__ - 1];
	}
/* L1: */
    }
/* -------- Normalize to peak */
    for (i__ = 1; i__ <= 501; ++i__) {
/* L2: */
	r__1 = field[i__ - 1] / emax;
	field[i__ - 1] = r_lg10(&r__1) * (float)20.;
    }
/* -------- Call a plotting package for rectangular plot */
    plot_(axis, field, &c__500);
    cl__1.cerr = 0;
    cl__1.cunit = 19;
    cl__1.csta = "DELETE";
    f_clos(&cl__1);
} /* MAIN__ */

/* Subroutine */ int lincur_(alen, npts, lunit)
real *alen;
integer *npts, *lunit;
{
    /* Initialized data */

    static real pi = (float)3.14159265;

    /* System generated locals */
    integer i__1;
    static real equiv_0[19];
    static complex equiv_1[10];

    /* Builtin functions */
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
#define frec ((real *)equiv_1)
#define ibuf ((integer *)equiv_0)
#define curm ((complex *)((integer *)equiv_1 + 13))
    static integer i__;
    static real aleni;
#define pk (equiv_0 + 2)
    static integer nn;

    /* Fortran I/O blocks */
    static cilist io___17 = { 0, 0, 0, 0, 1 };
    static cilist io___21 = { 0, 0, 0, 0, 0 };



/*  Currents file for uniform magnetic current along Z axis */

/*  ALEN    Length (wavelengths) */
/*  NPTS    Number of points */
/*  LUNIT   Logical unit of random access file with currents */

    *pk = pi * (float)2.;
/* ----------- Write first record: # points, current type, Propagation */
    ibuf[0] = *npts;
    ibuf[1] = 2;
    io___17.ciunit = *lunit;
    s_wdue(&io___17);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    curm[0].r = (float)0., curm[0].i = (float)0.;
    curm[1].r = (float)0., curm[1].i = (float)0.;
    curm[2].r = (float)1., curm[2].i = (float)0.;
    frec[0] = (float)0.;
    frec[1] = (float)0.;
    aleni = *alen / *npts;
    i__1 = *npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* ----------- Sample at center of each increment */
	frec[2] = -(*alen) / (float)2. + (i__ - (float).5) * aleni;
/* L1: */
	io___21.ciunit = *lunit;
	io___21.cirec = i__ + 1;
	s_wdue(&io___21);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* lincur_ */

#undef pk
#undef curm
#undef ibuf
#undef frec


/* Main program alias */ int po01_ () { MAIN__ (); }
