/* RINGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__3 = 3;
static real c_b12 = (float)1.;

/* Subroutine */ int ringeo_(axis, din, dout, vp, alinc, lunit, icat)
real *axis, *din, *dout, *vp, *alinc;
integer *lunit, *icat;
{
    /* Initialized data */

    static real pi = (float)3.14159654;
    static integer ia[3] = { 3,2,3 };

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue();
    double cos(), sin();
    integer s_wdue(), e_wdue();

    /* Local variables */
    static real frec[19];
    static integer krec, ibuf[19], i__, j;
    extern /* Subroutine */ int vlinc_(), euler_(), retsp_();
    static real r1, r2, hp, eu[3], hr;
    static integer nn;
    static real ph;
    static integer np;
    static real pp[3];
    static integer nr;
    static real sp[3];
    extern /* Subroutine */ int mtmult_();
    static real rad, vec[3], rot[9]	/* was [3][3] */;

    /* Fortran I/O blocks */
    static cilist io___10 = { 0, 0, 0, 0, 1 };
    static cilist io___23 = { 0, 0, 0, 0, 0 };
    static cilist io___24 = { 0, 0, 0, 0, 1 };



/*  Geometry file of Ring Disk rotated and located in space */
/*  Polar Grid */

/*  AXIS(3) Axis in direction of normal */
/*  DIN     Inner Diameter of disk */
/*  DOUT    Outer Diameter of disk */
/*  VP(3)   Location of center */
/*  ALINC   Length increment in aperture plane for current patches */
/*  LUNIT   Logical unit of random access file for currents */
/*  ICAT    If 1, concatenate */

    /* Parameter adjustments */
    --vp;
    --axis;

    /* Function Body */
    retsp_(&axis[1], sp);
/*  ------------- Find rotation matrix */
    eu[0] = sp[2];
    eu[1] = sp[1];
    eu[2] = (float)0.;
    euler_(eu, ia, rot);
    nr = (*dout - *din) / *alinc / (float)2. + (float).5;
    hr = (*dout - *din) / (float)2. / nr;
/*  ------------- Find normal */
    vec[0] = (float)0.;
    vec[1] = (float)0.;
    vec[2] = (float)1.;
    mtmult_(vec, rot, &frec[4], &c__1, &c__3, &c__3);
    if (*icat == 1) {
	io___10.ciunit = *lunit;
	s_rdue(&io___10);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
	}
	e_rdue();
	krec = ibuf[0] + 1;
    } else {
	krec = 1;
    }
/*  ------------- Loop over radius */
    i__1 = nr;
    for (j = 1; j <= i__1; ++j) {
	rad = ((real) (j - 1) + (float).5) * hr + *din / (float)2.;
/*  ------------- Find differential area on aperture plane */
	r1 = rad - hr / (float)2.;
	r2 = rad + hr / (float)2.;
	np = pi * (float)2. * rad / *alinc + (float).5;
	np /= 4;
	np = np + 1 << 2;
	hp = pi * (float)2. / np;
/*  ------------- Area of wedge */
/* Computing 2nd power */
	r__1 = r2;
/* Computing 2nd power */
	r__2 = r1;
	frec[3] = (r__1 * r__1 - r__2 * r__2) * hp / (float)2.;
/*  ------------- Loop over Phi */
	i__2 = np;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    ph = (real) (i__ - 1) * hp;
	    pp[0] = rad * cos(ph);
	    pp[1] = rad * sin(ph);
	    pp[2] = (float)0.;
	    mtmult_(pp, rot, vec, &c__1, &c__3, &c__3);
/*  ------------- Move to center of plate */
	    vlinc_(&c_b12, &vp[1], &c_b12, vec, frec);
	    ++krec;
/* L1: */
	    io___23.ciunit = *lunit;
	    io___23.cirec = krec;
	    s_wdue(&io___23);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
	}
/* L2: */
    }
    ibuf[0] = krec - 1;
    ibuf[1] = 1;
    io___24.ciunit = *lunit;
    s_wdue(&io___24);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* ringeo_ */

