/* VDIMUC.F -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

/* Table of constant values */

static real c_b5 = (float)-1.;
static real c_b6 = (float)1.;

/* Subroutine */ int vdimuc_(fd, al, alc, uu, ul, nptt, z12)
real *fd, *al, *alc, *uu, *ul;
integer *nptt;
complex *z12;
{
    /* Initialized data */

    static real xc[3] = { (float)0.,(float)0.,(float)0. };

    /* System generated locals */
    integer i__1, i__2;
    complex q__1, q__2, q__3, q__4;

    /* Builtin functions */
    double sin(), pow_ri();

    /* Local variables */
    static complex curc[3];
    static integer npts, i__, k;
    static real t, u[3];
    extern /* Complex */ VOID ccdot_();
    extern /* Subroutine */ int vlinc_();
    static complex efield[3];
    static real xb[1];
    static complex hfield[3], ss;
    extern /* Subroutine */ int blockn_();
    static real xs[3];
    extern /* Subroutine */ int nfpatr_();
    static real ari, cur, cur1, cur2;


/*  Mutual coupling between Vee Dipole and Currents File with dipole */
/*  (built in Simpson's rule integration) */

/*  FD(3)    Location of Vee Dipole */
/*  AL       Length of dipole (sum of arms) (m) */
/*  ALC      Length of dipole coupling to */
/*  UU(3)    Unit vector in direction of upper arm */
/*  UL(3)    Unit vector in direction of lower arm */
/*  NPTT	    Number of points */
/*  Z12      Mutual impedance */

    /* Parameter adjustments */
    --ul;
    --uu;
    --fd;

    /* Function Body */
    ss.r = (float)0., ss.i = (float)0.;
/* --------- Round points up to odd for Simpson's rule */
    npts = *nptt;
    if (npts % 2 == 0) {
	++npts;
    }
    ari = *al / ((npts - 1) * (float)2.);
/* --------------- Loop on arms */
    for (k = 1; k <= 2; ++k) {
	for (i__ = 1; i__ <= 3; ++i__) {
	    if (k == 2) {
		u[i__ - 1] = uu[i__];
	    }
	    if (k == 1) {
		u[i__ - 1] = ul[i__];
	    }
	    i__1 = i__ - 1;
	    i__2 = i__ - 1;
	    curc[i__1].r = u[i__2], curc[i__1].i = (float)0.;
/* L1: */
	}
/* --------------- Loop on arm */
	i__1 = npts;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    t = ari * (i__ - 1);
	    cur = sin(currenp_1.pkc * (*al / (float)2. - t)) * pow_ri(&c_b5, &
		    k) / (float)3.;
/* ---------- Simpson's rule weights */
	    if (i__ > 1 && i__ < npts) {
		if ((i__ - 1) % 2 == 1) {
		    cur *= (float)4.;
		}
		if ((i__ - 1) % 2 == 0) {
		    cur *= (float)2.;
		}
	    }
	    vlinc_(&c_b6, &fd[1], &t, u, xs);
	    nfpatr_(xc, blockn_, xb, xs, efield, hfield);
/* L2: */
	    ccdot_(&q__4, efield, curc);
	    q__3.r = cur * q__4.r, q__3.i = cur * q__4.i;
	    q__2.r = ari * q__3.r, q__2.i = ari * q__3.i;
	    q__1.r = ss.r + q__2.r, q__1.i = ss.i + q__2.i;
	    ss.r = q__1.r, ss.i = q__1.i;
	}
/* L3: */
    }
/* --------------- Find magnitude of currents at inputs to dipoles */
    cur1 = sin(*al * currenp_1.pkc / (float)2.);
    cur2 = sin(*alc * currenp_1.pkc / (float)2.);
    q__3.r = -ss.r, q__3.i = -ss.i;
    q__2.r = q__3.r / cur1, q__2.i = q__3.i / cur1;
    q__1.r = q__2.r / cur2, q__1.i = q__2.i / cur2;
    z12->r = q__1.r, z12->i = q__1.i;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* vdimuc_ */

