/* VGRHJN.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int vgrhjn_(xf, xs, pk, cur, h__)
real *xf, *xs, *pk;
complex *cur, *h__;
{
    /* Initialized data */

    static real fpi = (float)12.5663706;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5;

    /* Builtin functions */
    double sqrt(), cos(), sin();

    /* Local variables */
    static complex conp;
    static integer i__;
    static real r__, phase, rr[3];
    extern /* Subroutine */ int vcross_();


/*  Radiative Near field Vector Green's Function */

/*  Vector Green's function between source current density: J */
/*  and magnetic field: H */
/*  Vector Green's function between source current magnetic density: M */
/*  and the electric field: E when multiplied by -1 */

/*  XF(3)    Field point (units must match PK) */
/*  XS(3)    Source point (units must match PK) */
/*  PK       Propagation constant = 2*Pi/wavelength */
/*  CUR(3)   Rectangular coordinates of current (complex) */
/*           When summing in an integration, use current density times */
/*           area of the surface patch or current times length for a */
/*           filament.  Use meters**2 or meters and amps. */

/*  H(3)     Returned magnetic (-electric) field rectangular coord. */

    /* Parameter adjustments */
    --h__;
    --cur;
    --xs;
    --xf;

    /* Function Body */
    r__ = (float)0.;
/* ---------------- Find relative radius vector */
    for (i__ = 1; i__ <= 3; ++i__) {
	rr[i__ - 1] = xf[i__] - xs[i__];
/* L1: */
/* Computing 2nd power */
	r__1 = rr[i__ - 1];
	r__ += r__1 * r__1;
    }
    r__ = sqrt(r__);
/* ---------------- Normalize radius vector */
    for (i__ = 1; i__ <= 3; ++i__) {
/* L2: */
	rr[i__ - 1] /= r__;
    }
    phase = *pk * r__;
    q__4.r = (float)0., q__4.i = *pk;
    r__1 = cos(phase);
    r__2 = -sin(phase);
    q__5.r = r__1, q__5.i = r__2;
    q__3.r = q__4.r * q__5.r - q__4.i * q__5.i, q__3.i = q__4.r * q__5.i + 
	    q__4.i * q__5.r;
    q__2.r = q__3.r / fpi, q__2.i = q__3.i / fpi;
    q__1.r = q__2.r / r__, q__1.i = q__2.i / r__;
    conp.r = q__1.r, conp.i = q__1.i;
/* ---------------- Field components from currents */
    vcross_(rr, &cur[1], &h__[1]);
    for (i__ = 1; i__ <= 3; ++i__) {
/* L3: */
	i__1 = i__;
	q__2.r = -conp.r, q__2.i = -conp.i;
	i__2 = i__;
	q__1.r = q__2.r * h__[i__2].r - q__2.i * h__[i__2].i, q__1.i = q__2.r 
		* h__[i__2].i + q__2.i * h__[i__2].r;
	h__[i__1].r = q__1.r, h__[i__1].i = q__1.i;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* vgrhjn_ */

