      SUBROUTINE BLOCIU(XFD,PKC,ROT,BLOCK,XB,LUNIT)
C
C  Blockage surface currents added to Geometry File
C  for interpolated source
C
C  XFD(3)   Location of feed
C  PKC      Propagation constant
C
C  ROT(3,3) Rotation matrix
C  BLOCK    Blockage function (external) = 1 when blocked
C  XB       Array of variables for blockage function
C  LUNIT    Logical unit of random access currents file
C
      DIMENSION XFD(3),ROT(3,3),FREC(19),XB(1),XFR(3),SP(3),
     1 VR(3),VT(3),VP(3)
      COMPLEX CURJ(3),ETHETA,EPHI,PHA,HFIELD(3),UNIT(3),EFIELD(3),
     1 CURM(3)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK
      DATA ZZ/376.73/
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      PK=PKC
      IBUF(2)=0
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C  ------------- Loop over current patches
      DO 4 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C  ------------- Check for feed blockage
      IF(BLOCK(XB,XFD,FREC).NE.1)THEN
C  ------------- Find vector from feed to reflector point
      CALL VLINC(-1.,XFD,1.,FREC,XFR)
      CALL RETSP(XFR,SP)
      CALL FFDIRC(SP(2),SP(3),VR,VT,VP)
C  ------------- Find field
      CALL RINPAT(ROT,2,SP(2),SP(3),ETHETA,EPHI)
      PHASE=-SP(1)*PKC
      PHA=CMPLX(COS(PHASE),SIN(PHASE))/SP(1)
      DO 1 L=1,3
      UNIT(L)=VR(L)
    1 EFIELD(L)=(ETHETA*VT(L)+EPHI*VP(L))*PHA
      CALL CCROSS(UNIT,EFIELD,HFIELD)
      DO 2 J=1,3
      HFIELD(J)=HFIELD(J)/ZZ
    2 UNIT(J)=FREC(J+4)*FREC(4)
      CALL CCROSS(UNIT,HFIELD,CURJ)
      CALL CCROSS(EFIELD,UNIT,CURM)
      ELSE
C  ------------- Blocked
      DO 3 J=1,3
      CURM(J)=0.
    3 CURJ(J)=0.
      ENDIF
    4 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
