      PROGRAM CHYPAT
C
C  Pattern of Corrugated Waveguide Horn
C
C  Written   19 Mar 95
C  Last Edit 26 Apr 96
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION AMPL(361),PHASE(361),ANGLE(361),UF(3),VR(3),VT(3),
     1 VP(3),XF(3),XC(3),XB(3)
      COMPLEX ETH(361),EPH(361),EII,EF(3),HF(3),CURJA,CURMA,VE,VM,
     1 AP,BP
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,4000)
      COMMON /CURRENJ/CURJA(3,4000)
      COMMON /CURRENM/CURMA(3,4000)
      DIMENSION XHYB(4)
      COMMON /HYBM/XHYB
C
C  XHYB(1)  Waveguide Radius
C  XHYB(2)  Wall Reactance
C  XHYB(3)  Free space propagation constant
C  XHYB(4)  Circumferential mode number
C
      CHARACTER UN(3)*4
      EXTERNAL BLOCKN
      DATA PI/3.141592654/,TR/.01745329/,GCONS/.182637/,CC/.2997925/,
     1 UF/.0254,.01,1./,UN/' in.',' cm ',' m  '/,X01/2.40482555/,
     2 HCONS/68.805/,XC/0.,0.,0./
      IC=0
      OPEN(66,FILE='chypat.out')
      OPEN(19,FILE='chypat.dat',ACCESS='DIRECT',RECL=76)
    1 WRITE(6,2)
    2 FORMAT(' Pattern of Corrugated Waveguide Horn',/,
     1' Enter aperture diameter ',$)
      READ(5,*)DIAB
      WRITE(6,3)
    3 FORMAT(' Enter length units: 1 in., 2 cm, 3 m ',$)
      READ(5,*)IUN
      RADB=DIAB/2.*UF(IUN)
      WRITE(6,4)
    4 FORMAT(' Enter slant radius ',$)
      READ(5,*)SLANT
      SLAN=SLANT*UF(IUN)
      WRITE(6,5)
    5 FORMAT(' Enter mode type: 1 Corrugated, 2 TE smooth, 3 TM ',$)
      READ(5,*)ITYP
      IF(ITYP.EQ.1)THEN
      WRITE(6,6)
    6 FORMAT(' Enter depth of corrugations at aperture ',$)
      READ(5,*)DEPTH
      DEPT=DEPTH*UF(IUN)
      WRITE(66,7)DIAB,UN(IUN),SLANT,UN(IUN),DEPTH
    7 FORMAT(/,' Circular Corrugated horn',/,
     1' Diameter:                 ',F8.4,A4,/,
     2' Slant Radius:             ',F8.3,A4,/,
     3' Depth of corrugations:    ',F8.4)
      AKP=X01/RADB
      NM=1
      ELSE
      WRITE(6,8)
    8 FORMAT(' Enter Bessel Order, zero ',$)
      READ(5,*)NM,MM
      WRITE(66,9)DIAB,UN(IUN),SLANT,UN(IUN),NM,MM
    9 FORMAT(/,' Circular Waveguide Horn',/,
     1' Diameter:                 ',F8.4,A4,/,
     2' Slant Radius:             ',F8.3,A4,/,
     3' Bessel order, Zero:       ',I4,I4)
      IF(ITYP.EQ.1)WRITE(66,10)
      IF(ITYP.EQ.2)WRITE(66,11)
   10 FORMAT(' Smooth wall TE mode')
   11 FORMAT(' Smooth wall TM mode')
      IF(ITYP.EQ.2)CALL CEHCUT(RADB,NM,MM,AKP)
      IF(ITYP.EQ.3)CALL CMHCUT(RADB,NM,MM,AKP)
      ENDIF
      FREQC=.2997825*AKP/2./PI
      WRITE(6,12)
   12 FORMAT(' Enter X axis ampl(dB), phase ',$)
      READ(5,*)AX,PX
      AP=10.**(AX/20.)*CMPLX(COS(PX*TR),SIN(PX*TR))
      WRITE(6,13)
   13 FORMAT(' Enter Y axis ampl(dB), phase ',$)
      READ(5,*)AY,PY
      BP=10.**(AY/20.)*CMPLX(COS(PY*TR),SIN(PY*TR))
      WRITE(66,14)AX,PX,AY,PY
   14 FORMAT(' X axis Ampl.(dB):',F8.2,' Phase: ',F7.2,/,
     1' Y axis Ampl.(dB):',F8.2,' Phase: ',F7.2)
      WRITE(6,15)
   15 FORMAT(' Enter length increment for current patches ',$)
      READ(5,*)ALINC
      ALINU=ALINC*UF(IUN)
   16 WRITE(6,17)FREQC
   17 FORMAT(' Cutoff frequency = ',F8.3,
     1' Enter Frequency (GHz) ',$)
      READ(5,*)FREQ
      AKF=2.*PI*FREQ/CC
      IF(ITYP.EQ.1)THEN
      XS=376.73*TAN(DEPT*AKF)
      CALL HYMK11(RADB,XS,AKF,AKP)
      AKZ=SQRT(AKF**2-AKP**2)
      RATIO=-AKP*AKF*RADB*BESJPR(1,RADB*AKP)/
     1 (AKZ*BESSJN(1,RADB*AKP))
      FREQC=.2997825*AKP/2./PI
      WRITE(66,18)FREQC,XS,RATIO
      WRITE(6,18)FREQC,XS,RATIO
   18 FORMAT(
     1' Cutoff frequency (GHz):   ',F8.4,/,
     2' Wall reactance:           ',F8.1,/,
     3' Hybrid Ratio:             ',F8.4)
      VE=1.
      VM=RATIO
      ELSE IF(ITYP.EQ.2)THEN
      VE=1.
      VM=0.
      ELSE IF(ITYP.EQ.3)THEN
      VE=0.
      VM=1.
      ENDIF
      CALL CHRCUR(VE,VM,AP,BP,NM,RADB,SLAN,AKP,AKF,ALINU,19)
      CALL CURCOM(19)
      WRITE(66,19)FREQ,ALINC
   19 FORMAT(/,
     1' Operating Frequency (GHz):',F8.3,/,
     2' Edge length of patches:   ',F8.4)
   20 WRITE(6,21)
   21 FORMAT(' Pattern: 0 None, 1 Conic, 2 Great Circle ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.0)GOTO55
      IF(IPAT.EQ.1)THEN
      WRITE(6,22)
   22 FORMAT(' Enter Theta ',$)
      READ(5,*)THETA
      THT=THETA*TR
      WRITE(6,23)
   23 FORMAT(' Enter Phi Start,Stop,Step ',$)
      ELSE IF(IPAT.EQ.2)THEN
      WRITE(6,24)
   24 FORMAT(' Enter Phi ',$)
      READ(5,*)PHI
      PHT=PHI*TR
      WRITE(6,25)
   25 FORMAT(' Enter Theta  Start,Stop,Stop ',$)
      ENDIF
      READ(5,*)A1,A2,A3
      NA=(A2-A1)/A3+1.4
      IF(NA.GT.361)GOTO20
      WRITE(6,26)
   26 FORMAT(' Near field pattern? ',$)
      NEAR=NYES(K)
      IF(NEAR.EQ.1)THEN
      WRITE(6,27)UN(IUN)
   27 FORMAT(' Enter radius ',A4,' ',$)
      READ(5,*)DIST
      WRITE(66,28)DIST,UN(IUN)
   28 FORMAT(' Near Field Pattern at Radius = ',F8.3,A4)
      DIST=DIST*UF(IUN)
      WRITE(6,29)
   29 FORMAT(' Pattern based on magnetic field? ',$)
      MODEH=NYES(K)
      ELSE
      MODEH=-1
      ENDIF
      NUPAT=1
   30 WRITE(6,31)
   31 FORMAT(' Enter output: 1 E Theta, 2 E Phi, 3 RHC, 4 LHC,',/,
     1'      5 Max. Linear, 6 Min. Linear ',$)
      READ(5,*)IOUT
      WRITE(6,32)
   32 FORMAT(' Listing? ',$)
      LIST=NYES(K)
      IF(LIST.EQ.1)THEN
      IF(IPAT.EQ.1)THEN
      WRITE(66,33)THETA
      WRITE(6,33)THETA
   33 FORMAT(' Constant Theta = ',F7.2,/,
     1'   Phi   Amplitude  Phase')
   34 FORMAT(F8.1,F10.2,F8.2)
      ELSE IF(IPAT.EQ.2)THEN
      WRITE(66,35)PHI
      WRITE(6,35)PHI
   35 FORMAT(' Constant Phi = ',F7.2,/,
     1'   Theta  Amplitude  Phase')
      ENDIF
      ENDIF
      AEX=-500.
      DO37I=1,NA
      ANGLE(I)=A1+FLOAT(I-1)*A3
      IF(IPAT.EQ.1)PHT=ANGLE(I)*TR
      IF(IPAT.EQ.2)THT=ANGLE(I)*TR
      IF(NUPAT.EQ.1)THEN
      IF(NEAR.EQ.1)THEN
      CALL FFDIRC(THT,PHT,VR,VT,VP)
      DO 36 J=1,3
   36 XF(J)=VR(J)*DIST
      CALL NFPATR(XC,BLOCKN,XB,XF,EF,HF)
      IF(MODEH.EQ.1)THEN
      ETH(I)=(HF(1)*VT(1)+HF(2)*VT(2)+HF(3)*VT(3))*DIST
      EPH(I)=(HF(1)*VP(1)+HF(2)*VP(2)+HF(3)*VP(3))*DIST
      ELSE
      ETH(I)=(EF(1)*VT(1)+EF(2)*VT(2)+EF(3)*VT(3))*DIST
      EPH(I)=(EF(1)*VP(1)+EF(2)*VP(2)+EF(3)*VP(3))*DIST
      ENDIF
      ELSE
      CALL FFPATR(XC,BLOCKN,XB,THT,PHT,ETH(I),EPH(I))
      ENDIF
      IF(MODEH.EQ.1)THEN
      ETH(I)=ETH(I)*HCONS
      EPH(I)=EPH(I)*HCONS
      ELSE
      ETH(I)=ETH(I)*GCONS
      EPH(I)=EPH(I)*GCONS
      ENDIF
      ENDIF
      CALL OUTCC(IOUT,ETH(I),EPH(I),EII)
      CALL PMAGC(EII,AMPL(I),PHASE(I))
      IF(LIST.EQ.1)THEN
      WRITE(66,34)ANGLE(I),AMPL(I),PHASE(I)
      WRITE(6,34)ANGLE(I),AMPL(I),PHASE(I)
      ENDIF
      IF(AMPL(I).GT.AEX)AEX=AMPL(I)
   37 CONTINUE
      NUPAT=2
      IF(IC.EQ.0)EMAX=AEX
      WRITE(6,38)
   38 FORMAT(' Plot: 0 None, 1 Polar, 2 Rectangular ',$)
      READ(5,*)IPLOT
      IF(IPLOT.EQ.1)THEN
      IF(IC.NE.0)THEN
      WRITE(6,39)
   39 FORMAT(' Normalize to last plot maximum? ',$)
      KPM=NYES(K)
      IF(KPM.NE.1)EMAX=AEX
      ENDIF
      CALL PPATP(A1,A2,A3,AMPL,EMAX,IP)
      IC=1
      ELSE IF(IPLOT.EQ.2)THEN
      WRITE(6,80)
   80 FORMAT(' Plot amplitude? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(ANGLE,AMPL,NA)
      WRITE(6,81)
   81 FORMAT(' Plot phase? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(ANGLE,PHASE,NA)
      ENDIF
      WRITE(6,54)
   54 FORMAT(' Another polarization? ',$)
      IF(NYES(K).EQ.1)GOTO30
      GOTO20
   55 WRITE(6,56)
   56 FORMAT(' New frequency? ',$)
      IF(NYES(K).EQ.1)GOTO16
   57 WRITE(6,58)
   58 FORMAT(' Another horn? ',$)
      IF(NYES(K).EQ.1)GOTO1
      STOP
      END
      FUNCTION CEHZER(X)
C
C  Function to zero for radial propagation constant in Circular Waveguide
C
C  X(1)   Radial propagation constant
C  X(3)   Outer radius
C  X(4)   Bessel function order N
C
      DIMENSION X(4)
      N=X(4)
      CEHZER=BESJPR(N,X(1)*X(3))
      RETURN
      END
      SUBROUTINE CEHCUT(RADB,N,M,AKP)
C
C  Radial propagation constant for Circular Waveguide
C  (if zero, then root not found)
C
C  RADB   Outer radius (m)
C  N      Order of Bessel functions
C  M      Number of root
C
      DIMENSION X(4)
      EXTERNAL CEHZER
      DATA XACC/1.E-5/
      X(3)=RADB
      X(4)=N
      NN=0
      X(1)=.05/RADB
      X1=X(1)
      CE=CEHZER(X)
      DO1I=1,200
      X(1)=.1*I/RADB
      CB=CEHZER(X)
      IF(CE*CB.LE.0.)THEN
      X2=X(1)
      NN=NN+1
      IF(NN.EQ.M)THEN
      AKP=RTFLSP(CEHZER,X1,X2,X,1,XACC)
      RETURN
      ENDIF
      ENDIF
      CE=CB
    1 X1=X(1)
      AKP=0
      RETURN
      END
      FUNCTION CMHZER(X)
C
C  Function to zero for radial propagation constant in Circular Waveguide
C  for TM mode
C
C  X(1)   Radial propagation constant
C  X(3)   Outer radius
C  X(4)   Bessel function order N
C
      DIMENSION X(4)
      N=X(4)
      CMHZER=BESSJN(N,X(1)*X(3))
      RETURN
      END
      SUBROUTINE CMHCUT(RADB,N,M,AKP)
C
C  Radial propagation constant for Circular Waveguide in TM mode
C  (if zero, then root not found)
C
C  RADB   Outer radius (m)
C  N      Order of Bessel functions
C  M      Number of root
C
      DIMENSION X(4)
      EXTERNAL CMHZER
      DATA XACC/1.E-5/
      X(3)=RADB
      X(4)=N
      NN=0
      X(1)=.05/RADB
      X1=X(1)
      CE=CMHZER(X)
      DO1I=1,200
      X(1)=.1*I/RADB
      CB=CMHZER(X)
      IF(CE*CB.LE.0.)THEN
      X2=X(1)
      NN=NN+1
      IF(NN.EQ.M)THEN
      AKP=RTFLSP(CMHZER,X1,X2,X,1,XACC)
      RETURN
      ENDIF
      ENDIF
      CE=CB
    1 X1=X(1)
      AKP=0
      RETURN
      END
      FUNCTION RTFLSP(FUNC,X1,X2,X,NV,XACC)
C
C  Regula Falsi method for finding root of FUNC in interval:
C  X1 to X2 on variable NV of array X to within an accuracy XACC
C
      DIMENSION X(1)
      DATA MAXIT/30/
      RTF=1.5*X2
      X(NV)=X1
      FL=FUNC(X)
      X(NV)=X2
      FH=FUNC(X)
      IF(FL*FH.GT.0.)GOTO2
      IF(FL.LT.0.)THEN
      XL=X1
      XH=X2
      ELSE
      XL=X2
      XH=X1
      SWAP=FL
      FL=FH
      FH=SWAP
      ENDIF
      DX=XH-XL
      DO1J=1,MAXIT
      RTF=XL+DX*FL/(FL-FH)
      X(NV)=RTF
      F=FUNC(X)
      IF(F.LT.0.)THEN
      DEL=XL-RTF
      XL=RTF
      FL=F
      ELSE
      DEL=XH-RTF
      XH=RTF
      FH=F
      ENDIF
      DX=XH-XL
      IF(ABS(DEL).LT.XACC.OR.F.EQ.0.)GOTO2
    1 CONTINUE
      RTF=.66*X1
    2 RTFLSP=RTF
      RETURN
C
C  Ref:  Press, Flannery, Teukolsky, and Vetterling, NUMERICAL RECIPES,
C        Cambridge University Press, New York, 1986, pp. 248.
C
      END
      SUBROUTINE PMAGC(E,AMP,PHASE)
      COMPLEX E
      IF(CABS(E).GT.1.E-12)THEN
      AMP=20.*ALOG10(CABS(E))
      PHASE=ATAN2(AIMAG(E),REAL(E))/.01745329
      ELSE
      AMP=-240.
      PHASE=0
      ENDIF
      RETURN
      END
      SUBROUTINE OUTCC(IOUT,ET,EP,E)
C
C  CONVERTS THETA and PHI COMPONENTS (VOLTAGE) TO
C  AMPLITUDE DB AND PHASE DEG.
C
C  IOUT
C    1 E THETA (HORIZONTAL), 2 E PHI (VERTICAL), 3 RHC, 4 LHC,
C    5 MAX LINEAR, 6 MIN LINEAR
C  ET, EP COMPLEX THETA & PHI COMPONENTS (VOLTAGE)
C  E OUTPUT VOLTAGE
C
      COMPLEX ET,EP,E,F,CJ
      DATA S2/1.4142135/,CJ/(0.,1.)/
      GOTO(1,2,3,4,5,6,8,9,11),IOUT
    1 E=ET
      GOTO7
    2 E=EP
      GOTO7
    3 E=(ET+CJ*EP)/S2
      GOTO7
    4 E=(ET-CJ*EP)/S2
      GOTO7
    5 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)+CABS(F))/S2
      GOTO7
    6 E=(ET+CJ*EP)/S2
      F=(ET-CJ*EP)/S2
      E=(CABS(E)-CABS(F))/S2
      GOTO7
    8 E=(ET+EP)/S2
      GOTO7
    9 E=(ET-EP)/S2
      GOTO7
   11 E= SQRT(CABS(ET)**2+CABS(EP)**2)
      GOTO7
    7 RETURN
      END
