      SUBROUTINE CPACUR(RADIUS,FREQ,POL,NPTS,LUNIT)
C
C  Currents file of circular microstrip patch
C
C  RADIUS    Effective radius of patch (m)
C  FREQ      Frequency (GHz)
C  POL	     Polarization: 0 linear, -1 RHC, +1 LHC
C  NPTS      Number of points in integrals
C
C  LUNIT     Logical unit of random access file with currents
C
      DIMENSION FREC(19)
      INTEGER*4 IBUF(19)
      COMPLEX CURM(3),AM(3)
      EQUIVALENCE (IBUF(3),PK),(FREC(14),CURM(1))
      DATA CC/.2997925/,PI/3.141592654/
      WAVEL=CC/FREQ
      PK=2.*PI/WAVEL
      RAD=RADIUS/WAVEL
C --------------- Find maximum magnetic current for 1 w. input
      AMM=2.*SQRT(1./CRADCN(RAD))
      IBUF(1)=NPTS
      IBUF(2)=2
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      KREC=1
      PER=2.*PI*RADIUS
      HP=PER/NPTS
      DO 2 I=1,NPTS
      POS=HP*(I-1)
      CALL CPPERM(POS,RADIUS,FREC,AM,POL)
      KREC=KREC+1
      DO 1 K=1,3
    1 CURM(K)=AM(K)*AMM*HP
      WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
    2 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
