      SUBROUTINE CURCON(PKC,VR,HFIELD,NPLTS,LUNIT,ITER)
C
C  Currents convergence for Incident plane wave
C
C  PKC    Propagation constant
C  VR(3)  Incident wave direction
C  HFIELD Incident wave magnetic field
C  NPLTS  Number of plates
C  LUNIT  Array of logical units
C
      DIMENSION VR(3),LUNIT(1),XBB(1),XC(3)
      COMPLEX HFIELD(3)
      EXTERNAL BLOCKN
      DATA XC/0.,0.,0./
C  -----------  Find initial currents into first files
      DO 2 IP=1,NPLTS
      CALL REFPCU(PKC,VR,HFIELD,BLOCKN,XBB,LUNIT(IP),1)
C  ----------- Move geometry into third files
      IPP=IP+2*NPLTS
      CALL CUREQU(LUNIT(IP),LUNIT(IPP))
      IPP=IP+NPLTS
C  -----------  Move initial currents into second files
    2 CALL CUREQU(LUNIT(IP),LUNIT(IPP))
C  -----------  Loop for convergence
      DO 6 INR=1,ITER
C  ----------- Move all currents into common except plate
      DO 4 IP=1,NPLTS
      K=1
      DO 3 IL=1,NPLTS
      IF(IP.EQ.IL)GOTO3
      IPP=IL+NPLTS
      IF(K.EQ.1)THEN
      CALL CURCOM(LUNIT(IPP))
      K=2
      ELSE
      CALL CURCAT(LUNIT(IPP))
      ENDIF
    3 CONTINUE
C  ----------- Find third file currents due to currents in common
      IPP=IP+2*NPLTS
      CALL REFCUR(XC,PKC,BLOCKN,XBB,LUNIT(IPP),0)
    4 CONTINUE
C  ----------- Sum currents into 1st file
      DO 5 IP=1,NPLTS
      IPP=IP+2*NPLTS
      CALL CURADD(LUNIT(IP),LUNIT(IPP))
C  ----------- Move third file currents into second files
      IQQ=IP+NPLTS
    5 CALL CUREQU(LUNIT(IPP),LUNIT(IQQ))
    6 CONTINUE
C  ----------- Concatenate currents into common
      CALL CURCOM(LUNIT(1))
      DO 7 I=2,NPLTS
    7 CALL CURCAT(LUNIT(I))
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
