      SUBROUTINE CURROT(ROT,CENT)
C
C  Rotation of Currents in Common about point in space
C
C  ROT(3,3)   Rotation matrix
C  CENT(3)    Center of rotation
C
      DIMENSION ROT(3,3),CENT(3),XC(3),XA(3)
      COMPLEX CURJA,CURMA,CURJI(3),CURJO(3),CURMI(3),CURMO(3)
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
C
C  CURRENT Common
C
C  NCUR     Number of points
C  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only
C  PKC      Propagation constant (1./meters)
C  POSC     Position of current element (meters)
C  CURJA    Electric current * area rectangular components (complex)
C  CURMA    Magnetic current * area rectangular components (complex)
C
      DO 3 K=1,NCUR
      DO 1 J=1,3
      XC(J)=POSC(J,K)-CENT(J)
      CURJI(J)=CURJA(J,K)
    1 CURMI(J)=CURMA(J,K)
      CALL MTMULT(XC,ROT,XA,1,3,3)
      CALL CVTROT(CURJI,ROT,CURJO)
      CALL CVTROT(CURMI,ROT,CURMO)
      DO 2 J=1,3
      POSC(J,K)=XA(J)+CENT(J)
      CURJA(J,K)=CURJO(J)
    2 CURMA(J,K)=CURMO(J)
    3 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
