      FUNCTION DSKBLN(XB,XS,XF)
C
C  Disk blockage function for near field
C
C  XB(1)  X position of disk center
C     2   Y position of disk center
C     3   Z position of disk center
C     4   Radius of disk
C     5   Unit normal to disk (X component)
C     6   Unit normal to disk (Y component)
C     7   Unit normal to disk (Z component)
C  XS     Source point
C  XF     Field point
C
      DIMENSION XB(1),XS(1),XF(1),P(3),FS(3)
      CALL VLINC(-1.,XS,1.,XF,FS)
      FSL=SQRT(DOT(FS,FS))
      DO 1 I=1,3
    1 FS(I)=FS(I)/FSL
      DSKBLN=0.
      CALL PINTS(XS,FS,XB(1),XB(5),T,P,NIS)
      IF(NIS.EQ.-1)RETURN
      DIST=SQRT((P(1)-XB(1))**2+(P(2)-XB(2))**2+(P(3)-XB(3))**2)
      IF(DIST.GT.XB(4).OR.T.LT.0.)RETURN
      IF(DIST.LE.XB(4).AND.T.GT.FSL)RETURN
      DSKBLN=1
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
