      SUBROUTINE DURGEO(DMAIN,DSUB,FOD,FED,TYPE,A,B,CENT,FEED)
C
C  Dual Reflector Geometry
C
C  DMAIN    Diameter of main reflector
C  DSUB     Diameter of subreflector
C  FOD      Main reflector f/D
C  FED      Effective f/D of dual reflector system
C  TYPE     1) Hyperboloid (Cassegrain), 2) Ellipsoid (Gregorian)
C
C  A	    Z-axis factor of subreflector curve
C  B	    Radial factor of subreflector curve
C  CENT(3)  Location of center of subreflector geometry
C  FFED(3)  Location of feed
C
      DIMENSION CENT(3),FEED(3)
      AMAG=FED/FOD
      E=(AMAG+1.)/(AMAG-1.)
      IF(TYPE.EQ.2)E=1./E
C -------- Half subtended of main and subreflector at focus & feed
      PHIO=2.*ATAN(1./(4.*FOD))
      THO=2.*ATAN(1./(4.*FED))
      IF(TYPE.EQ.1)THEN
      PZ=2.*E*E/(E*E-1.)
      P=DSUB*(E*COS(THO)-1.)/(2.*E*SIN(THO))
      ELSE IF(TYPE.EQ.2)THEN
      PZ=2.*E*E/(1.-E*E)
      P=-DSUB*(E*COS(THO)-1.)/(2.*E*SIN(THO))
      ENDIF
C -------- Subreflector parameters 2*C, A, and B
      TC=PZ*P
      A=TC/2./E
      B=SQRT(ABS((TC/2.)**2-A**2))
      FOCUS=FOD*DMAIN
      FEED(1)=0.
      FEED(2)=0.
      FEED(3)=FOCUS-TC
      CENT(1)=0.
      CENT(2)=0.
      CENT(3)=FOCUS-TC/2.
      RETURN
      END
