      FUNCTION ELLBLN(XB,XS,XF)
C
C  Elliptical Disk Blockage function for near field
C
C  XB(1)   X position of disk center
C    (2)   Y position of disk center
C    (3)   Z position of disk center
C    (4)   Major Axis Radius
C    (5)   Minor Axis Radius
C    (6)   Unit normal to disk (X component)
C    (7)   Unit normal to disk (Y component)
C    (8)   Unit normal to disk (Z component)
C    (9)   Unit vector from center along major axis (X component)
C    (10)  Unit vector from center along major axis (Y component)
C    (11)  Unit vector from center along major axis (Z component)
C  XS      Source point
C  XF      Field point
C
      DIMENSION XB(1),XS(1),XF(1),P(3),Y(3),RV(3),FS(3)
      ELLBLN=0.
      CALL VLINC(-1.,XS,1.,XF,FS)
      FSL=SQRT(DOT(FS,FS))
      DO 1 I=1,3
    1 FS(I)=FS(I)/FSL
      CALL PINTS(XS,FS,XB(1),XB(7),T,P,NIS)
      IF(NIS.EQ.-1)RETURN
      CALL CROSS(XB(6),XB(9),Y)
      CALL VLINC(1.,P,-1.,XB,RV)
      V=(DOT(RV,XB(9))/XB(4))**2+(DOT(RV,Y)/XB(5))**2-1.
      IF(V.LE.0.)ELLBLN=1.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
