      SUBROUTINE FFPATR(XC,BLOCK,XB,THETA,PHI,ETHETA,EPHI)
C
C  Far field pattern from currents in common
C
C  XC(3)     Position of center of currents
C  BLOCK     Blockage function (external) = 1 when blocked
C  XB        Array of variables for blockage function
C  THETA     Angle from Z axis (boresight) (radians)
C  PHI       Spherical angle from X-axis (radians)
C  ETHETA    Electric field in Theta direction
C  EPHI      Electric field in Phi direction
C
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
C
C  CURRENT Common
C
C  NCUR     Number of points
C  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only
C  PKC      Propagation constant (1/meters)
C  POSC     Position of current element (meters)
C  CURJA    Electric current * area rectangular components (complex)
C  CURMA    Magnetic current * area rectangular components (complex)
C
      COMPLEX CURJA,CURMA,ETHETA,EPHI,CURJ(3),CURM(3),ETH,EPH,CONJ
      DIMENSION VR(3),VT(3),VP(3),XS(3),XC(3),XB(1)
      EXTERNAL BLOCK
      DATA CC/.2997925/,PI/3.141592654/
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
C ------------- -j*2*Pi*Frequency*Mu
      CONJ=CMPLX(0.,-PKC*CC*400.*PI)
      ETHETA=0.
      EPHI=0.
      DO 2 I=1,NCUR
      DO 1 J=1,3
      XS(J)=POSC(J,I)+XC(J)
      CURJ(J)=CURJA(J,I)
    1 CURM(J)=CURMA(J,I)
      IF(BLOCK(XB,XS,VR).EQ.0)THEN
      IF(NCTYP.LT.2)THEN
C --------- Electric currents available
      CALL VGREJF(VR,VT,VP,XS,PKC,CURJ,ETH,EPH)
      ETHETA=ETHETA+ETH*CONJ
      EPHI=EPHI+EPH*CONJ
      ENDIF
      IF(NCTYP.NE.1)THEN
C --------- Magnetic currents available
      CALL VGRHJF(VR,VT,VP,XS,PKC,CURM,ETH,EPH)
      ETHETA=ETHETA-ETH
      EPHI=EPHI-EPH
      ENDIF
      ENDIF
    2 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
