      SUBROUTINE GRHJC(XF,XS,PK,GHJ)
C
C  Complete: Near and Far Field
C
C  Dyadic Green's function between source current density: J
C  and the magnetic field: H  when multiplied by j  or
C  Dyadic Green's function between source magnetic current density: M
C  and the electric field: E when multiplied by -j
C
C  XF(3)   Field point
C  XS(3)   Source point
C  PK      Propagation constant: units of XF, XS, PK should match
C          If the fields are expressed V/m, then the units should be m
C
      DIMENSION XF(3),XS(3),RCI(3,3)
      COMPLEX GHJ(3,3),CONP
      DATA FPI/12.5663706/
      CALL RCROSSI(XF,XS,RCI,R)
      PHASE=PK*R
      CONP=-CMPLX(1./R,PK)*CMPLX(COS(PHASE),-SIN(PHASE))/FPI/R
      DO1I=1,3
      DO1J=1,3
    1 GHJ(I,J)=CONP*RCI(I,J)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
