      SUBROUTINE NFPATF(LUNIT,XC,BLOCK,XB,XF,EFIELD,HFIELD)
C
C  Near field pattern from currents in file
C
C  LUNIT     Logical unit of open file
C  XC(3)     Position of center of currents
C  BLOCK     Blockage function (external) = 1 when blocked
C  XB        Array of variables for blockage function
C  XF(3)     Field point (meters)
C  EFIELD    Electric field (V/m)
C  HFIELD    Magnetic field
C
      COMPLEX CURJ(3),CURM(3),EFIELD(3),HFIELD(3),EF(3),
     1 HF(3),CONJ,CONM,GEJ(3,3),GHJ(3,3)
      DIMENSION XS(3),XF(3),XC(3),XB(1),FREC(19)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(1),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK
      DATA CC/.2997925/,PI/3.141592654/,EPS/8.854185E-3/
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------------- -j*2*Pi*Frequency*Mu  ------ electric field factor
      CONJ=CMPLX(0.,-PK*CC*400.*PI)
C ------------- -j*2*Pi*Frequency*epsilon -- magnetic field factor
      CONM=CMPLX(0.,-PK*CC*EPS)
      NCUR=IBUF(1)
      NCTYP=IBUF(2)
      DO 1 I=1,3
      EFIELD(I)=0.
    1 HFIELD(I)=0.
C --------- Loop on current patches
      DO 5 I=1,NCUR
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
      DO 2 J=1,3
    2 XS(J)=FREC(J)+XC(J)
C --------- Check for blockage
      IF(BLOCK(XB,XS,XF).EQ.0.)THEN
      CALL GREJC(XF,XS,PK,GEJ)
      CALL GRHJC(XF,XS,PK,GHJ)
      IF(NCTYP.LT.2)THEN
C --------- Electric currents available
      CALL CMTMUL(GEJ,CURJ,EF)
      CALL CMTMUL(GHJ,CURJ,HF)
      DO 3 J=1,3
      HFIELD(J)=HFIELD(J)+HF(J)
    3 EFIELD(J)=EFIELD(J)+EF(J)*CONJ
      ENDIF
      IF(NCTYP.NE.1)THEN
C --------- Magnetic currents available
      CALL CMTMUL(GEJ,CURM,HF)
      CALL CMTMUL(GHJ,CURM,EF)
      DO 4 J=1,3
      EFIELD(J)=EFIELD(J)-EF(J)
    4 HFIELD(J)=HFIELD(J)+HF(J)*CONM
      ENDIF
      ENDIF
    5 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
