      SUBROUTINE NRPATF(LUNIT,XC,BLOCK,XB,XF,EFIELD,HFIELD)
C
C  Radiative Near field pattern from currents in file
C
C  XC(3)     Position of center of currents
C  BLOCK     Blockage function (external) = 1 when blocked
C  XB        Array of variables for blockage function
C  XF        Field point (meters)
C  EFIELD    Electric field (V/m)
C  HFIELD    Magnetic field
C
      COMPLEX CURJ(3),CURM(3),EFIELD(3),HFIELD(3),EF(3),
     1 HF(3),CONJ,CONM
      DIMENSION XS(3),XF(3),XC(3),XB(1),FREC(19)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK
      DATA CC/.2997925/,PI/3.141592654/,EPS/8.854185E-3/
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------------- -j*2*Pi*Frequency*Mu  ------ electric field factor
      CONJ=CMPLX(0.,-PK*CC*400.*PI)
C ------------- -j*2*Pi*Frequency*epsilon -- magnetic field factor
      CONM=CMPLX(0.,-PK*CC*EPS)
      NCUR=IBUF(1)
      NCTYP=IBUF(2)
      DO 1 I=1,3
      EFIELD(I)=0.
    1 HFIELD(I)=0.
C --------- Loop on current patches
      DO 7 I=1,NCUR
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
      DO 2 J=1,3
    2 XS(J)=FREC(J)+XC(J)
C --------- Check for ray blockage
      IF(BLOCK(XB,XS,XF).EQ.0)THEN
      IF(NCTYP.LT.2)THEN
C --------- Electric currents available
      CALL VGREJN(XF,XS,PK,CURJ,EF)
      DO 3 J=1,3
    3 EFIELD(J)=EFIELD(J)+EF(J)*CONJ
      CALL VGRHJN(XF,XS,PK,CURJ,HF)
      DO 4 J=1,3
    4 HFIELD(J)=HFIELD(J)+HF(J)
      ENDIF
      IF(NCTYP.NE.1)THEN
C --------- Magnetic currents available
      CALL VGREJN(XF,XS,PK,CURM,HF)
      DO 5 J=1,3
    5 HFIELD(J)=HFIELD(J)+HF(J)*CONM
      CALL VGRHJN(XF,XS,PK,CURM,EF)
      DO 6 J=1,3
    6 EFIELD(J)=EFIELD(J)-EF(J)
      ENDIF
      ENDIF
    7 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
