      FUNCTION PATEXP(BW,BL,NAPPR)
C
C  Pattern Approximation  I: E = cos(Theta/2)**N Pattern Exponent
C                        II: E = cos(Theta)**N   Pattern Exponent
C
C  BWE     Beamwidth  (degrees)
C  BLE     Beamwidth level (dB)
C  NAPPR   Approximation number
C
      DATA TR/.01745329/
      CCA=COS(BW*TR*.25*NAPPR)
      IF(CCA.LT.0)THEN
C --------------- Impossible beamwidth
      PATEXP=0
      ELSE
      PATEXP=-ABS(BL)/(20.*ALOG10(CCA))
      ENDIF
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
