      SUBROUTINE PATROT(ROT,VR,VT,VP,THETA,PHI,VTP,VPP)
C
C  Rotates Pattern direction in prime coordinates to rotated
C  antenna coordinates
C
C  ROT(3,3)   Rotation matrix
C  VR(3)      Pattern direction unit vector
C  VT(3)      Theta unit vector for VR direction
C  VP(3)      Phi unit vector for VR direction
C
C  THETA      Pattern direction in rotated antenna coordinates
C  PHI        Pattern direction in rotated antenna (radians)
C  VTP(3)     Direction of Theta component in rotated coordinates
C  VPP(3)     Direction of  Phi  component in rotated coordinates
C
      DIMENSION ROT(3,3),VR(3),VT(3),VP(3),VTP(3),VPP(3),XX(3),SP(3)
      CALL MTMULT(ROT,VR,XX,3,3,1)
      CALL RETSP(XX,SP)
      THETA=SP(2)
      PHI=SP(3)
      CALL MTMULT(ROT,VT,VTP,3,3,1)
      CALL MTMULT(ROT,VP,VPP,3,3,1)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
