      PROGRAM PLSRCS
C
C  RCS of group of polygon plates using PO
C
C  Written   10 Apr 95
C  Last Edit 21 May 95
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION FREQ(361),VR(3),VT(3),VP(3),XC(3),VCC(3),
     1 UNITS(4),VTR(3,36),EU(3),IAA(3),ROT(3,3),XBB(112),RCS(361),
     2 LUNIT(21),ARM(3,3)
      COMPLEX HFIELD(3),CURJA,CURMA,ETHETA,EPHI
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,2000)
      COMMON /CURRENJ/CURJA(3,2000)
      COMMON /CURRENM/CURMA(3,2000)
      CHARACTER POFILE*40,CUNIT(4)*4,PLRCSD(21)*40,PATHF*21
      EXTERNAL POLBKF,BLOCKN
      DATA TR/.01745329/,RCONS/.009409677/,XC/0.,0.,0./,
     1 UNITS/.0254,.3048,.01,1./,CUNIT/' in.',' ft.',' cm.',' m. '/,
     2 PI/3.141592654/,CC/.2997925/,ARM/1.,0.,0.,0.,1.,0.,0.,0.,1./
      OPEN(66,FILE='plsrcs.out')
      OPEN(19,FILE='plsrcs.dat',ACCESS='DIRECT',RECL=76)
      WRITE(6,1)
    1 FORMAT(' RCS of polygon plate; Enter multiple plate file ',$)
      READ(5,2)POFILE
    2 FORMAT(A40)
      OPEN(15,FILE=POFILE)
      WRITE(6,3)
    3 FORMAT(' Enter units of point: 1 in. 2 ft, 3 cm, 4 m ',$)
      READ(5,*)IUNIT
      READ(15,*)NPLTS
      WRITE(66,5)POFILE,NPLTS
    5 FORMAT(' RCS of group of polygon plates',/,
     1' Polygons input file: ',A40,/,
     2' Number of plates = ',I2)
      WRITE(6,6)
    6 FORMAT(' Enter currents file prefix ',$)
      READ(5,8)PATHF
    8 FORMAT(A21)
C  ------------------- Loop on number of plates
      DO 34 IP=1,NPLTS
      XMAX=-50000.
      XMIN=50000.
      YMAX=-50000.
      YMIN=50000.
C
C  File structure
C
C  NPLTS    Number of plates
C
C  NV       Number of vertices
C  VTR(1-3) Vertices
C  Euler angles
C  Euler axis numbers
C  Number of points along X & Y axes
C  Translation after rotation (X,Y,Z)
C
C  ------------------- Read vertices in X-Y plane
      READ(15,*)NV
      DO 4 I=1,NV
      READ(15,*)VTR(1,I),VTR(2,I)
      VTR(3,I)=0.
      IF(VTR(1,I).GT.XMAX)XMAX=VTR(1,I)
      IF(VTR(1,I).LT.XMIN)XMIN=VTR(1,I)
      IF(VTR(2,I).GT.YMAX)YMAX=VTR(2,I)
      IF(VTR(2,I).LT.YMIN)YMIN=VTR(2,I)
      VTR(1,I)=VTR(1,I)*UNITS(IUNIT)
      VTR(2,I)=VTR(2,I)*UNITS(IUNIT)
    4 CONTINUE
C  ------------------- Read euler angles of plate rotation
      READ(15,*)EU1,EU2,EU3
      EU(1)=EU1*TR
      EU(2)=EU2*TR
      EU(3)=EU3*TR
C  ------------------- Read axes numbers
      READ(15,*)IAA(1),IAA(2),IAA(3)
      CALL EULER(EU,IAA,ROT)
      WRITE(6,7)IP,NV,XMIN,XMAX,CUNIT(IUNIT),YMIN,YMAX,
     1 EU1,EU2,EU3,IAA(1),IAA(2),IAA(3)
      WRITE(66,7)IP,NV,XMIN,XMAX,CUNIT(IUNIT),YMIN,YMAX,
     1 EU1,EU2,EU3,IAA(1),IAA(2),IAA(3)
    7 FORMAT(' Polygon plate: 'I2,/,
     1' Number of vertices:            ',I8,/,
     2' Range along X axis of plate:   ',F8.3,2X,F8.3,A4,/,
     2' Range along Y axis of plate:   ',F8.3,2X,F8.3,/,
     3' Rotation Angles:               ',3F8.2,/,
     4' Axes: 1 X, 2 Y, 3 Z:           ',3I8)
      XMIN=XMIN*UNITS(IUNIT)
      XMAX=XMAX*UNITS(IUNIT)
      YMIN=YMIN*UNITS(IUNIT)
      YMAX=YMAX*UNITS(IUNIT)
C  -------------------- Prepare blockage function with vertices
      CALL POLBKP(VTR,NV,XC,ARM,XBB)
C  -------------------- Number of X,Y increments
      READ(15,*)NX,NY
      WRITE(66,10)NX,NY
   10 FORMAT(
     1' Number of X axis patches:      ',I8,/,
     2' Number of Y axis patches:      ',I8)
C  -------------------- Translation of plate
      READ(15,*)VCC(1),VCC(2),VCC(3)
      WRITE(66,9)VCC(1),VCC(2),VCC(3)
    9 FORMAT(
     3' Translation of plate:          ',3F8.3)
      VCC(1)=VCC(1)*UNITS(IUNIT)
      VCC(2)=VCC(2)*UNITS(IUNIT)
      VCC(3)=VCC(3)*UNITS(IUNIT)
C  -------------------- Create PO patches geometry file
      CALL FILNN(PATHF,IP,PLRCSD(IP))
      LUNIT(IP)=IP+20
      OPEN(LUNIT(IP),FILE=PLRCSD(IP),ACCESS='DIRECT',RECL=76)
      IPP=IP+NPLTS
      CALL FILNN(PATHF,IPP,PLRCSD(IPP))
      LUNIT(IPP)=IPP+20
      OPEN(LUNIT(IPP),FILE=PLRCSD(IPP),ACCESS='DIRECT',RECL=76)
      IPP=IP+2*NPLTS
      CALL FILNN(PATHF,IPP,PLRCSD(IPP))
      LUNIT(IPP)=IPP+20
      OPEN(LUNIT(IPP),FILE=PLRCSD(IPP),ACCESS='DIRECT',RECL=76)
      CALL PLBGEO(XMIN,XMAX,YMIN,YMAX,POLBKF,XBB,VCC,NX,NY,LUNIT(IP))
   34 CALL GEOROT(LUNIT(IP),ROT,XC,VCC)
   11 WRITE(6,12)
   12 FORMAT(' Enter 0 stop, Vary: 1 Frequency, 2 Angle, 3 Bistatic ',$)
      READ(5,*)ITASK
      IF(ITASK.EQ.0)STOP
      WRITE(6,35)
   35 FORMAT(' Enter number of iterations ',$)
      READ(5,*)ITER
      WRITE(6,13)
   13 FORMAT(' Enter polarization: 1 Theta, 2 Phi ',$)
      READ(5,*)IPOL
      IF(IPOL.EQ.1)WRITE(66,14)ITER
      IF(IPOL.EQ.2)WRITE(66,15)ITER
   14 FORMAT(/,' Incident wave Theta polarized iterations: ',I3)
   15 FORMAT(/,' Incident wave Phi polarized  iterations: ',I3)
      IF(ITASK.NE.2)THEN
      WRITE(6,16)
   16 FORMAT(' Enter incident angles (Theta,Phi) w.r.t. Z-axis ',$)
      READ(5,*)THETA,PHI
      WRITE(66,17)THETA,PHI
   17 FORMAT(' Incident wave direction: Theta: ',F7.2,'  Phi: ',F7.2)
      CALL FFDIRC(THETA*TR,PHI*TR,VR,VT,VP)
      ENDIF
      IF(ITASK.NE.1)THEN
      WRITE(6,18)
   18 FORMAT(' Enter frequency (GHz) ',$)
      READ(5,*)FREQU
      PKC=2.*PI*FREQU/CC
      WRITE(66,19)FREQU
   19 FORMAT(' Frequency (GHz) = ',F8.3)
      WRITE(6,20)
   20 FORMAT(' Vary: 1 Phi, 2 Theta ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.1)THEN
      WRITE(6,21)
   21 FORMAT(' Enter Theta ',$)
      READ(5,*)THETA
      WRITE(66,22)THETA
   22 FORMAT(' Constant Theta = ',F7.2)
      ELSE IF(IPAT.EQ.2)THEN
      WRITE(6,23)
   23 FORMAT(' Enter Phi ',$)
      READ(5,*)PHI
      WRITE(66,24)PHI
   24 FORMAT(' Constant Phi = ',F7.2)
      ENDIF
      IF(IPOL.EQ.1)THEN
      HFIELD(1)=VP(1)
      HFIELD(2)=VP(2)
      HFIELD(3)=VP(3)
      ELSE
      HFIELD(1)=VT(1)
      HFIELD(2)=VT(2)
      HFIELD(3)=VT(3)
      ENDIF
      IF(ITASK.EQ.3)CALL CURCON(PKC,VR,HFIELD,NPLTS,LUNIT,ITER)
      ENDIF
      IF(ITASK.EQ.1)THEN
C  -------------------- Vary frequency
      WRITE(6,25)
   25 FORMAT(' Enter frequency (GHz)  start,stop,step ',$)
      ELSE
C  -------------------- Vary angle
      WRITE(6,26)
   26 FORMAT(' Enter angle  start,stop,step ',$)
      ENDIF
      READ(5,*)F1,F2,F3
      NF=(F2-F1)/F3+1.4
      IF(NF.GT.361)GOTO 11
      IF(ITASK.EQ.1)THEN
      WRITE(66,27)
      WRITE(6,27)
   27 FORMAT(' Frequency  RCS dBsm')
      ELSE IF(ITASK.EQ.2)THEN
      WRITE(66,28)
      WRITE(6,28)
   28 FORMAT(' Backscatter',/,'  Angle   RCS dBsm')
      ELSE IF(ITASK.EQ.3)THEN
      WRITE(66,29)
      WRITE(6,29)
   29 FORMAT(' Bistatic Scattering',/,'  Angle   RCS dBsm')
      ENDIF
      DO 30 I=1,NF
      FREQ(I)=F1+FLOAT(I-1)*F3
      IF(ITASK.NE.1)THEN
      IF(IPAT.EQ.1)THEN
      PH=FREQ(I)*TR
      TH=THETA*TR
      ELSE
      PH=PHI*TR
      TH=FREQ(I)*TR
      ENDIF
      ENDIF
      IF(ITASK.EQ.1)PKC=2.*PI*FREQ(I)/CC
      IF(ITASK.EQ.2)CALL FFDIRC(TH,PH,VR,VT,VP)
      IF(ITASK.NE.3)THEN
      IF(IPOL.EQ.1)THEN
      HFIELD(1)=VP(1)
      HFIELD(2)=VP(2)
      HFIELD(3)=VP(3)
      ELSE
      HFIELD(1)=VT(1)
      HFIELD(2)=VT(2)
      HFIELD(3)=VT(3)
      ENDIF
      CALL CURCON(PKC,VR,HFIELD,NPLTS,LUNIT,ITER)
      ENDIF
      CALL FFPATR(XC,BLOCKN,XBB,TH,PH,ETHETA,EPHI)
      IF(IPOL.EQ.1)RCS(I)=20.*ALOG10(RCONS*CABS(ETHETA))
      IF(IPOL.EQ.2)RCS(I)=20.*ALOG10(RCONS*CABS(EPHI))
      IF(ITASK.EQ.1)WRITE(66,31)FREQ(I),RCS(I)
      IF(ITASK.EQ.1)WRITE(6,31)FREQ(I),RCS(I)
      IF(ITASK.NE.1)WRITE(66,32)FREQ(I),RCS(I)
      IF(ITASK.NE.1)WRITE(6,32)FREQ(I),RCS(I)
   30 CONTINUE
   31 FORMAT(F9.4,F10.2)
   32 FORMAT(F7.2,F10.2)
      WRITE(6,33)
   33 FORMAT(' Plot? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(FREQ,RCS,NF)
      GOTO11
      END
      SUBROUTINE FILNN(PATHP,NUMB,FILE)
C
C  Constructs File Name for Data File: PATHP.NUM
C 
C  PATHP   Character String with Path and preamble
C  NUMB    Number between 999 and 1 
C  FILE    Output File Name 
C 
      CHARACTER PATHP*21,NUM*3,FILE*40
      ICC=NUMB
      DO5I=1,2
      IB=ICC/10.**(3-I) 
      NUM(I:I)=CHAR(IB+48)
    5 ICC=ICC-IB*10**(3-I)
      NUM(3:3)=CHAR(ICC+48) 
      DO1I=21,1,-1
      IF(PATHP(I:I).NE.' ')GOTO2
    1 CONTINUE
    2 FILE=PATHP(1:I)//'.'//NUM
      RETURN
      END
