      SUBROUTINE PYRGEO(HEIGHT,ALINC,XPB,LUNIT)
C
C  Pyramid Geometry Generation
C
C  HEIGHT   Height of pyramid above plane
C  ALINC    Minimum length along edges
C  XPB      Blockage of array of base polygon
C  LUNIT    Logical unit of random access file for currents
C
      DIMENSION XPB(1),PP1(3),PP2(3),PP3(3),TP1(3),TP2(3),TP3(3),
     1 FREC(19),CENT(3)
      INTEGER*4 IBUF(19)
      NV=XPB(1)+.1
      CENT(1)=0.
      CENT(2)=0.
      CENT(3)=0.
C  ------------- Find center point of polygon
      DO 1 I=1,NV
      DO 1 J=1,3
    1 CENT(J)=CENT(J)+XPB(3*I+J+1)/NV
C  ------------- Find vertex of pyramid
      CALL VLINC(1.,CENT,HEIGHT,XPB(2),PP1)
C  ------------- Loop on base vertices
      KREC=1
      DO 10 I=1,NV
      K=MOD(I,NV)+1
C  ------------- Find vertices of triangle
      DO 2 J=1,3
      PP2(J)=XPB(3*I+J+1)+ALINC*XPB(J+1)
      PP3(J)=XPB(3*K+J+1)+ALINC*XPB(J+1)
      TP1(J)=PP2(J)-PP1(J)
      TP2(J)=PP3(J)-PP1(J)
    2 TP3(J)=PP3(J)-PP2(J)
C  ------------- Find patches normal to plane
      EDGE=SQRT(DOT(TP3,TP3))
      IS3=EDGE/ALINC+1
      FREC(4)=ALINC*EDGE/IS3
      CALL CROSS(TP3,XPB(2),FREC(5))
      AN=SQRT(DOT(FREC(5),FREC(5)))
      DO 3 J=1,3
    3 FREC(J+4)=FREC(J+4)/AN
      DO 4 II=1,IS3
      FAC=(FLOAT(II)-.5)/FLOAT(IS3)
      CALL VLINC(1.,PP2,FAC,TP3,FREC)
      ALC=-ALINC/2.
      CALL VLINC(1.,FREC,ALC,XPB(2),FREC)
      KREC=KREC+1
    4 WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
C  ------------- Find unit normal to plane
      CALL CROSS(TP1,TP2,FREC(5))
      AN=SQRT(DOT(FREC(5),FREC(5)))
      DO 5 J=1,3
    5 FREC(J+4)=FREC(J+4)/AN
      IS1=SQRT(DOT(TP1,TP1))/ALINC+1
      IS2=SQRT(DOT(TP2,TP2))/ALINC+1
      NSUB=MAX0(IS1,IS2,IS3)
C  ------------ Subdivide triangle
      DO 9 II=0,NSUB-1
      DO 8 JJ=0,II
C  ------------ Righted triangles
      DO 6 KK=1,3
      TP1(KK)=PP1(KK)+II*(PP2(KK)-PP1(KK))/NSUB
     1 +JJ*(PP3(KK)-PP2(KK))/NSUB
      TP2(KK)=PP1(KK)+(II+1)*(PP2(KK)-PP1(KK))/NSUB
     1 +JJ*(PP3(KK)-PP2(KK))/NSUB
    6 TP3(KK)=PP1(KK)+(II+1)*(PP2(KK)-PP1(KK))/NSUB
     1 +(JJ+1)*(PP3(KK)-PP2(KK))/NSUB
      CALL TRIAN(TP1,TP2,TP3,FREC(1),FREC(4))
      KREC=KREC+1
      WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
      IF(II.GT.0.AND.JJ.LT.II)THEN
C  ------------ Upside down triangles
      DO 7 KK=1,3
      TP1(KK)=PP1(KK)+II*(PP2(KK)-PP1(KK))/NSUB
     1 +JJ*(PP3(KK)-PP2(KK))/NSUB
      TP2(KK)=PP1(KK)+II*(PP2(KK)-PP1(KK))/NSUB
     1 +(JJ+1)*(PP3(KK)-PP2(KK))/NSUB
    7 TP3(KK)=PP1(KK)+(II+1)*(PP2(KK)-PP1(KK))/NSUB
     1 +(JJ+1)*(PP3(KK)-PP2(KK))/NSUB
      CALL TRIAN(TP1,TP2,TP3,FREC(1),FREC(4))
      KREC=KREC+1
      WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
      ENDIF
    8 CONTINUE
    9 CONTINUE
   10 CONTINUE
      IBUF(1)=KREC-1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      RETURN
      END
      SUBROUTINE TRIAN(P1,P2,P3,PC,AREA)
C
C  Triangle in space
C
C  P1, P2, P3  Vertices (input)
C  PC          Center of area
C  AREA        Area of triangle
C
      DIMENSION P1(3),P2(3),P3(3),PC(1)
      D1=SQRT(DOT(P1,P2))
      D2=SQRT(DOT(P2,P3))
      D3=SQRT(DOT(P3,P1))
      S=D1+D2+D3
      AREA=SQRT(S*(S-D1)*(S-D2)*(S-D3))
      DO 1 I=1,3
    1 PC(I)=(P1(I)+P2(I)+P3(I))/3.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
