      SUBROUTINE RCSPAT(ROT,NAP,THETA,PHI,BNE,BNH,POL,ETHETA,EPHI)
C
C  Rotated
C  Pattern approximation  I: E = cos(Theta/2)**N
C                        II: E = cos(Theta)**N
C
C  ROT(3,3) Rotation matrix
C  NAP      Pattern approximation number
C  THETA    Pattern angle (radians)
C  PHI      Pattern angle (radians)
C  BNE      Exponent in E plane
C  BNH      Exponent in H plane
C  POL      Polarization: 0 Linear, -1 RHC, +1 LHC
C  ETHETA   Theta component  V/m for 1 watt radiated power at 1 m.
C  EPHI     Phi component    V/m for 1 watt radiated power at 1 m.
C
      COMPLEX ETHETA,EPHI,ETHETE,EPHE
      DIMENSION ROT(3,3),VR(3),VT(3),VP(3),VTP(3),VPP(3),
     1 VRR(3),VTR(3),VPR(3)
C ------------ Find unit vectors for pattern direction
      CALL FFDIRC(THETA,PHI,VR,VT,VP)
C ------------ Express VR in element coordinates for pattern
C              directions & Express VT and VP in element coordinates
      CALL PATROT(ROT,VR,VT,VP,THETE,PHE,VTP,VPP)
C ------------ Find pattern
      CALL COSPAT(NAP,THETE,PHE,BNE,BNH,POL,ETHETE,EPHE)
C ------------ Find unit vectors in element coordinate system
      CALL FFDIRC(THETE,PHE,VRR,VTR,VPR)
C ------------ Project element components onto re-expressed
C              unit vectors to find components
      ETHETA=ETHETE*DOT(VTR,VTP)+EPHE*DOT(VPR,VTP)
      EPHI=ETHETE*DOT(VTR,VPP)+EPHE*DOT(VPR,VPP)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
