      SUBROUTINE REFCUR(XFD,PKC,BLOCK,XB,LUNIT,IADD)
C
C  Reflector surface currents added to Geometry File
C  using Current Common
C
C  XFD(3)   Location of feed - Assumes currents centered on feed
C  PKC      Propagation constant
C  BLOCK    Blockage function
C  XB       Blockage function array
C  LUNIT    Logical unit of random access currents file
C  IADD     If 1, add currents to existing currents
C
C  The routine assumes that the currents in common have been rotated
C  to the proper orientation to point at the reflector; see FILROT
C
      DIMENSION XFD(3),FREC(19),XB(1)
      INTEGER*4 IBUF(19)
      COMPLEX CURJ(3),EFIELD(3),HFIELD(3),UNIT(3),CURM(3)
      EQUIVALENCE (FREC(8),CURJ(1)),(FREC(14),CURM(1)),(IBUF(3),PK)
      EXTERNAL BLOCK
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      IBUF(2)=1
      PK=PKC
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      DO 3 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C  ----------- Find fields at the surface of the reflector
      CALL NFPATR(XFD,BLOCK,XB,FREC,EFIELD,HFIELD)
      DO 1 J=1,3
      CURM(J)=0.
C  ----------- 2*(Surface Normal)*(Patch Area)
    1 UNIT(J)=2.*FREC(J+4)*FREC(4)
      CALL CCROSS(UNIT,HFIELD,EFIELD)
      DO 2 J=1,3
      IF(IADD.NE.1)CURJ(J)=EFIELD(J)
      IF(IADD.EQ.1)CURJ(J)=CURJ(J)+EFIELD(J)
    2 CONTINUE
    3 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
