      SUBROUTINE REFPCU(PKC,XINC,HFIELD,BLOCK,XB,LUNIT,INOUT)
C
C  Reflector surface currents added to Geometry File
C  Due to Plane Wave Incident
C
C  PKC      Propagation constant
C  XINC(3)  Unit vector in direction of plane wave
C  HFIELD   Incident magnetic field
C  BLOCK    Blockage function (external) = 1 when blocked
C  XB       Array of variables for blockage function
C  LUNIT    Logical unit of random access currents file
C  INOUT    +1 only use when normal towards plane wave
C           -1 only use when normal away from plane wave
C            0 either
C
      DIMENSION FREC(19),XB(1),XINC(3)
      COMPLEX CURJ(3),CURM(3),PHA,HFIELD(3),UNIT(3)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      PK=PKC
      IBUF(2)=1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C  ------------- Loop over current patches
      DO 4 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C  ------------- Check for blockage
      IF(BLOCK(XB,FREC,XINC).NE.1.AND.DOT(XINC,FREC(5))*INOUT.GE.0.)
     1 THEN
C  ------------- Find distance to reference plane
      PHASE=DOT(FREC,XINC)*PKC
      PHA=CMPLX(COS(PHASE),SIN(PHASE))
      DO 2 J=1,3
      CURM(J)=0.
    2 UNIT(J)=2.*FREC(J+4)*FREC(4)*PHA
      CALL CCROSS(UNIT,HFIELD,CURJ)
      ELSE
C  ------------- Blocked
      DO 3 J=1,3
    3 CURJ(J)=0.
      ENDIF
    4 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
