      SUBROUTINE RFSCCU(XFD,PKC,ROT,NAP,BNE,BNH,POL,BLOCK,XB,LUNIT,IADD)
C
C  Reflector surface currents added to Geometry File
C  using pattern approximation
C  Shadow only normal toward feed included
C
C  XFD(3)   Location of feed
C  PKC      Propagation constant
C
C  Rotated
C  Pattern approximation  I: E = cos(Theta/2)**N
C                        II: E = cos(Theta)**N
C
C  ROT(3,3) Rotation matrix
C  NAP      Pattern approximation number
C  BNE      Exponent in E plane
C  BNH      Exponent in H plane
C  POL      Polarization: 0 Linear, -1 RHC, +1 LHC
C  BLOCK    Blockage function (external) = 1 when blocked
C  XB       Array of variables for blockage function
C  LUNIT    Logical unit of random access currents file
C
      DIMENSION XFD(3),ROT(3,3),FREC(19),XB(1),XFR(3),SP(3),
     1 VR(3),VT(3),VP(3)
      COMPLEX CURJ(3),ETHETA,EPHI,PHA,HFIELD(3),UNIT(3),CUJJ(3),CURM(3)
      INTEGER*4 IBUF(19)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      EXTERNAL BLOCK,SHADOW
      DATA ZZ/376.73/
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      PK=PKC
      IBUF(2)=1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C  ------------- Loop over current patches
      DO 4 I=1,IBUF(1)
      READ(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C  ------------- Check for feed blockage
      IF(BLOCK(XB,XFD,FREC).NE.1.AND.SHADOW(FREC(5),XFD,FREC).NE.1)THEN
C  ------------- Find vector from feed to reflector point
      CALL VLINC(-1.,XFD,1.,FREC,XFR)
      CALL RETSP(XFR,SP)
      CALL FFDIRC(SP(2),SP(3),VR,VT,VP)
C  ------------- Find field
      CALL RCSPAT(ROT,NAP,SP(2),SP(3),BNE,BNH,POL,ETHETA,EPHI)
      PHASE=-SP(1)*PKC
      PHA=CMPLX(COS(PHASE),SIN(PHASE))
      DO 1 J=1,3
      CURM(J)=0.
      UNIT(J)=FREC(J+4)*FREC(4)
    1 HFIELD(J)=2.*(VP(J)*ETHETA-VT(J)*EPHI)*PHA/SP(1)/ZZ
      CALL CCROSS(UNIT,HFIELD,CUJJ)
      ELSE
C  ------------- Blocked
      DO 2 J=1,3
      CURM(J)=0.
    2 CUJJ(J)=0.
      ENDIF
      DO 3 J=1,3
      IF(IADD.EQ.1)CURJ(J)=CURJ(J)+CUJJ(J)
      IF(IADD.NE.1)CURJ(J)=CUJJ(J)
    3 CONTINUE
    4 WRITE(LUNIT,REC=I+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
