      SUBROUTINE RINGEO(AXIS,DIN,DOUT,VP,ALINC,LUNIT,ICAT)
C
C  Geometry file of Ring Disk rotated and located in space
C  Polar Grid
C
C  AXIS(3) Axis in direction of normal
C  DIN     Inner Diameter of disk
C  DOUT    Outer Diameter of disk
C  VP(3)   Location of center
C  ALINC   Length increment in aperture plane for current patches
C  LUNIT   Logical unit of random access file for currents
C  ICAT    If 1, concatenate
C
      DIMENSION VP(1),FREC(19),PP(3),AXIS(3),SP(3),ROT(3,3),EU(3),
     1 IA(3),VEC(3)
      INTEGER*4 IBUF(19)
      DATA PI/3.14159654/,IA/3,2,3/
      CALL RETSP(AXIS,SP)
C  ------------- Find rotation matrix
      EU(1)=SP(3)
      EU(2)=SP(2)
      EU(3)=0.
      CALL EULER(EU,IA,ROT)
      NR=(DOUT-DIN)/ALINC/2.+.5
      HR=(DOUT-DIN)/2./NR
C  ------------- Find normal
      VEC(1)=0.
      VEC(2)=0.
      VEC(3)=1.
      CALL MTMULT(VEC,ROT,FREC(5),1,3,3)
      IF(ICAT.EQ.1)THEN
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      KREC=IBUF(1)+1
      ELSE
      KREC=1
      ENDIF
C  ------------- Loop over radius
      DO 2 J=1,NR
      RAD=(FLOAT(J-1)+.5)*HR+DIN/2.
C  ------------- Find differential area on aperture plane
      R1=RAD-HR/2.
      R2=RAD+HR/2.
      NP=2.*PI*RAD/ALINC+.5
      NP=NP/4
      NP=(NP+1)*4
      HP=2.*PI/NP
C  ------------- Area of wedge
      FREC(4)=(R2**2-R1**2)*HP/2.
C  ------------- Loop over Phi
      DO 1 I=1,NP
      PH=FLOAT(I-1)*HP
      PP(1)=RAD*COS(PH)
      PP(2)=RAD*SIN(PH)
      PP(3)=0.
      CALL MTMULT(PP,ROT,VEC,1,3,3)
C  ------------- Move to center of plate
      CALL VLINC(1.,VP,1.,VEC,FREC)
      KREC=KREC+1
    1 WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
    2 CONTINUE
      IBUF(1)=KREC-1
      IBUF(2)=1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
