      SUBROUTINE RPPERM(P,RL,W,POS,AM,IEDGE,POL)
C
C  Perimeter function of rectangular patch
C
C  P   Perimeter value
C  RL  Resonant length along X axis
C  W   Non-resonant width
C  POS    Position on patch centered on origin
C  AM(3)  Normalized magnetic current direction
C  IEDGE  Edge number: Intersects axis: 1 +X, 2 +Y, 3 -X, 4 -Y
C  POL    Polarization: 0 Linear, -1 RHC, +1 LHC
C
      DIMENSION POS(3)
      COMPLEX AM(3)
      DATA PI/3.141592654/,S2/1.4142135/
      POS(3)=0.
      AM(3)=0.
      IF(IEDGE.EQ.1)THEN
      POS(1)=RL/2.
      POS(2)=-W/2.+P
      AM(1)=0.
      AM(2)=1.
      IF(POL.NE.0.)AM(2)=(AM(2)-CMPLX(0.,POL)*SIN(POS(2)*PI/2.))/S2
      ELSE IF(IEDGE.EQ.2)THEN
      POS(1)=-RL/2.+P
      POS(2)=W/2.
      AM(1)=-SIN(POS(1)*PI/2.)
      AM(2)=0.
      IF(POL.NE.0.)AM(1)=(AM(1)-CMPLX(0.,POL))/S2
      ELSE IF(IEDGE.EQ.3)THEN
      POS(1)=-RL/2.
      POS(2)=-W/2.+P
      AM(1)=0.
      AM(2)=1.
      IF(POL.NE.0.)AM(2)=(AM(2)+CMPLX(0.,POL)*SIN(POS(2)*PI/2.))/S2
      ELSE IF(IEDGE.EQ.4)THEN
      POS(1)=-RL/2.+P
      POS(2)=-W/2.
      AM(1)=SIN(POS(1)*PI/2.)
      AM(2)=0.
      IF(POL.NE.0.)AM(1)=(AM(1)-CMPLX(0.,POL))/S2
      ENDIF
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
