      SUBROUTINE SUBBGE(XMIN,XMAX,YMIN,YMAX,A,B,TYPE,BLOCK,XB,
     1 VP,NX,NY,LUNIT)
C
C  Subreflector Geometry for Currents File
C  using rectangular grid and external blockage function for rim
C
C  XMIN    Minimum X axis position of rim
C  XMAX    Maximum X axis position of rim
C  YMIN    Minimum Y axis position of rim
C  YMAX    Maximum Y axis position of rim
C  A       Denominator factor of Z
C  B       Denominator factor of X & Y
C  TYPE    1) Hyperboloid (Cassegrain)  2) Ellipsoid (Gregorian)
C  BLOCK   External blockage function to determine rim shape
C  XB( )   Blockage function variables
C  VP(3)   Location of hyperboloid (ellipsoid) center
C
C  Note:   Hyperboloid (ellipsoid) axis along Z-axis
C          and located on positive Z-axis
C  LUNIT   Logical unit of random access file for currents
C
      DIMENSION VP(1),FREC(19),PP(3),XB(1),VR(3)
      INTEGER*4 IBUF(19)
      EXTERNAL BLOCK
      DATA VR/0.,0.,1./
      KREC=1
      HX=(XMAX-XMIN)/NX
      HY=(YMAX-YMIN)/NY
      KREC=1
C  ------------- Loop over X-axis
      DO 2 J=1,NX
      PP(1)=XMIN+HX*(J-.5)
      DO 1 I=1,NY
      PP(2)=YMIN+HY*(I-.5)
      PP(3)=-1.
      IF(BLOCK(XB,PP,VR).EQ.1.)THEN
C  ------------- Point within rim
      RP=SQRT(PP(1)**2+PP(2)**2)
      PP(3)=A*SQRT(1.-(RP/B)**2*(-1.)**TYPE)
C  ------------- Find unit normal
      IF(TYPE.EQ.1)CALL HYPNM(PP,A,B,FREC(5))
      IF(TYPE.EQ.2)CALL ELLNM(PP,A,B,FREC(5))
C  ------------- Adjust area
      FREC(4)=HX*HY/ABS(FREC(7))
      CALL VLINC(1.,VP,1.,PP,FREC)
      KREC=KREC+1
      WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
      ENDIF
    1 CONTINUE
    2 CONTINUE
      IBUF(1)=KREC-1
      IBUF(2)=1
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      RETURN
      END
