      SUBROUTINE VGREJF(VR,VT,VP,XS,PK,CUR,ETHETA,EPHI)
C
C  Far field Vector Green's Function
C
C  Vector Green's function between source current density: J
C  and electric field: E when multiplied by -j(2*pi*frequency)*mu
C  Vector Green's function between source current magnetic density: M
C  and the magnetic field: H when multiplied by -j(2*Pi*freq*epsilon)
C
C  VR(3)    Radial unit vector
C  VT(3)    Theta directed unit vector
C  VP(3)    Phi directed unit vector
C  XS(3)    Position of current element
C  PK       Propagation constant = 2*Pi/wavelength
C  CUR(3)   Rectangular coordinates of current density (complex)
C
C  ETHETA   Theta component of electric (magnetic) field
C  EPHI     Phi component of electric (magnetic) field
C
      DIMENSION VR(3),VT(3),VP(3),XS(3)
      COMPLEX CUR(3),CONP,ETHETA,EPHI
      DATA FPI/12.5663706/
      PHASE=PK*DOT(VR,XS)
      CONP=CMPLX(COS(PHASE),SIN(PHASE))/FPI
C ---------------- Field components from currents
      ETHETA=(CUR(1)*VT(1)+CUR(2)*VT(2)+CUR(3)*VT(3))*CONP
      EPHI=(CUR(1)*VP(1)+CUR(2)*VP(2)+CUR(3)*VP(3))*CONP
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
