      SUBROUTINE VSLCUR(FREQ,FD,AL,UU,UL,NPTT,CURR,LUNIT)
C
C  Currents file for Vee Slot (built in Simpson's rule integration)
C
C  FREQ    Frequency (GHz)
C  FD(3)   Feed point (m)
C  AL	   Length of slot (sum of both arms) (m)
C  UU(3)   Direction of unit vector of upper arm
C  UL(3)   Direction of unit vector of lower arm
C  NPTT    Number of points along each arm
C  CURR    Multiplier on current magnitude (for mutual = 1)
C  LUNIT   Logical unit of file for currents
C
      DIMENSION FREC(19),FD(3),UU(3),UL(3),U(3)
      INTEGER*4 IBUF(19)
      COMPLEX CURM(3)
      EQUIVALENCE (IBUF(3),PK),(FREC(14),CURM(1))
      DATA CC/.2997925/,PI/3.141592654/
      WAVEL=CC/FREQ
      PK=2.*PI/WAVEL
C --------- Round points up to odd for Simpson's rule
      NPTS=NPTT
      IF(MOD(NPTS,2).EQ.0)NPTS=NPTS+1
      IBUF(1)=2*NPTS
      IBUF(2)=2
      WRITE(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      KREC=1
      AI=AL/(2.*(NPTS-1))
      CURC=CURR/3.
C ---------- Loop on arms
      DO 4 K=1,2
      DO 1 I=1,3
      IF(K.EQ.1)U(I)=UU(I)
      IF(K.EQ.2)U(I)=UL(I)
    1 CONTINUE
C ---------- Loop on points along slot
      DO 3 I=1,NPTS
      T=(I-1)*AI
      CALL VLINC(1.,FD,T,U,FREC)
      CUR=-SIN(PK*(AL/2.-T))*CURC*AI*(-1.)**K
C ---------- Simpson's rule weights
      IF(I.GT.1.AND.I.LT.NPTS)THEN
      IF(MOD(I-1,2).EQ.1)CUR=CUR*4.
      IF(MOD(I-1,2).EQ.0)CUR=CUR*2.
      ENDIF
C ---------- Normal currents including Simpson's weights
      DO 2 J=1,3
    2 CURM(J)=U(J)*CUR
      KREC=KREC+1
    3 WRITE(LUNIT,REC=KREC)(FREC(NN),NN=1,19)
    4 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
