% MATLAB script file for calculating far-field 
% patterns of vector electric point source inside
% spherical equivalent surface.
%
% PART c: calculates the re-radiated patterns
% Expected previous files: po6a, po06b

Nthp=101;		% number of theta pattern angles

thp1=0;		% pattern theta start angle, radians
thp2=pi;		% pattern theta end angle, radians	
nthp=(1:Nthp)';		% theta pattern index array
phpat=0;		% phi angle of pattern
dthp=(thp2-thp1)/(Nthp-1);	% theta increment

thp=thp1+(nthp-1)*dthp;% Nthp by 1 array,theta angles
thpd=180/pi*thp;	% in degrees
php=phpat*ones(Nthp,1);% Nthp by 1 array, phi angles

EM=propff01(req,Mn,thp,php,k0);	
			% FF electric field from Mn
HJ=-propff01(req,Jn,thp,php,k0);
			% FF magnetic field from Jn

Ppth=abs(4*pi/2/Z0*(EM(:,1)+HJ(:,2)*Z0).^2);
Ppph=abs(4*pi/2/Z0*(EM(:,2)-HJ(:,1)*Z0).^2);
PpthdB=10*log10(Ppth);
PpphdB=10*log10(Ppph);


plot(thpd,PpthdB);grid;axis([0 180 -30 10])

%