% MATLAB script file for calculating far-field 
% patterns of pyramidal horn
% 
% PART a: define variables
%

lam=1;			% wavelength
k0=2*pi/lam;		% wavenumber
Z0=376.7;		% free-space characteristic impedance

r0=[0 0 0];		% aperure center position vector
un0=[0 0 1];		% unit normal of aperture
ut2=[0 1 0];		% unit vector in aperture y dimension
ut1=cross01(ut2,un0);	% in apertue x dimension

wx=2*lam;		% aperture x dimension
wy=2*lam;		% aperture y)dimension
thxd=30;		% x-z plane flare angle, deg
thyd=30;		% y-z plane flare angle, deg

dxm=.25*lam;	% x maximum sampling spacing
dym=.25*lam;	% y maximum sampling spacing

mTEx=[1 0];	% TE x-mode array
mTEy=[0 1];	% TE y-mode array
mTMx=[0];	% TM x-mode array
mTMy=[0];	% TM y-mode array

ITE=[1 -i]*Z0;	% TE current relative excitations
NTE=length(ITE);	% number of TE modes
IITE=ones(size(ITE));	% 1 by NTE array of ones

VTM=[0];		% TM voltage relative excitation
NTM=length(VTM);	% number of TM modes
IVTM=ones(size(VTM));	% 1 by NTM array of ones

thd1=-180;	% theta cut start angle, deg
thd2=180;	% theta stop angle, deg
Nth=361;	% number of theta angles
phd=0;		% phi angle for theta cut

%