% MATLAB script file for calculating far-field
% patterns of open-ended waveguide
%
% Part b: calculates the aperture geometry
%

Nsxp=ceil(wx/dxm+1);	% number of x samples, waveguide
Nsyp=ceil(wy/dym+1);	% number of y samples, waveguide
Ns=Nsxp*Nsyp;		% total number of samples

dxp=wx/Nsxp;		% actual x' sample spacing, wg
dyp=wy/Nsyp;		% actual y' sample spacing, wg

nxp=(1:Nsxp)';	% Nsxp by 1 array, x' indices
nyp=(1:Nsyp);		% 1 by Nsyp array, y' indices

xsp=(nxp-.5)*dxp-wx/2;	% Nsxp by 1 array, x' sample coords
ysp=(nyp-.5)*dyp-wy/2;	% 1 by Nsyp array, y' sample coords

Ix=ones(Nsxp,1);	% Nsxp by 1 array of ones
Iy=ones(1,Nsyp);	% 1 by Nsyp array of ones

xsa=xsp*Iy;		% Nsxp by Nsyp array of sample x coords
ysa=Ix*ysp;		% Nsxp by Nsyp array of sample y coords

xp=reshape(xsa,Ns,1);		% x primed coordinates
yp=reshape(ysa,Ns,1);		% y primed coordinates

rs=xp*ut1+yp*ut2+ones(Ns,1)*r0; % Ns by 3 array, sample position vectors
dS=dxp*dyp*ones(Ns,1);	% source sampling areas (normalized)

u1=ones(Ns,1)*ut1;% Ns by 3 array, first tan unit vector
u2=ones(Ns,1)*ut2;% Ns by 3 array, second tan unit vect
un=ones(Ns,1)*un0;% Ns by 3 array, unit normal

%