% MATLAB script file for calculating far-field 
% patterns of vector electric point source on circular 
% perfectly-absorbing groundplane

%
% PART a: input parameters
%

lam=1;		% wavelength
k0=2*pi/lam;	% wavenumber
Z0=376.7;	% free-space characteristic impedance

rs=[0 0 0];		% source position vector
J0=lam*sqrt(3/Z0/pi);	% electric source current 
Jr=[0 0 1];		% source orientation

Req=3*lam;	% radius of groundplane
dthsmax=.35*lam;	% max eq surface sampling interval, theta 
dphsmax=.45*lam;	% max eq surface sampling interval, phi 

thd1=-180; 	% pattern start angle, deg
thd2=180;	% pattern stop angle, deg
Nth=301;	% number of theta pattern angles
Nthg=40;	% number of theta angle subarrays
phdp=0;		% phi angle of theta pattern

%
