% MATLAB script file for calculating far-field 
% patterns of vector electric point source on circular 
% perfectly-absorbing groundplane
%
% PART d: equivalent surface currents
% previous m-files: po10a, po10b, po10c
%

ut=norm01(req-ones(Neq,1)*rs); 	% unit vect, source to field

Hs=-propnf01(rs,Js,req,k0);	% source H field
Es=-Z0*cross01(ut,Hs);	% source E field
Jeq=cross01(uneq,Hs);		% eq electric current 
Meq=-cross01(uneq,Es);		% eq magnetic current
Mn=Meq.*(dSeq*ones(1,3));	% normalized current
Jn=Jeq.*(dSeq*ones(1,3)); 	% normalized current

%
