% MATLAB script file for calculating far-field 
% patterns of vector electric point source on circular 
% impedance groundplane
%
% PART a: input parameters
%

lam=1;		% wavelength
k0=2*pi/lam;	% wavenumber
Z0=376.7;	% free-space characteristic impedance

rs=[0 0 lam/4];		% source position vector
J0=lam*sqrt(3/Z0/pi);	% electric source current 
Jr=[0 1 0];		% source orientation

% ZsTE=0;	% groundplane surface impedances
% ZsTM=ZsTE;	% groundplane is in x-y plane

er=2.2;
hc=lam/16/sqrt(er);

ZsTE=-i*Z0/sqrt(er)*tan(k0*sqrt(er)*hc);
ZsTM=ZsTE;

Req=3*lam;	% radius of groundplane
dthsmax=.35*lam;% max eq surface sampling interval, theta 
dphsmax=.35*lam;% max eq surface sampling interval, phi 

thd1=-180; 	% pattern start angle, deg
thd2=180;	% pattern stop angle, deg
Nth=361;	% number of theta pattern angles
Nthg=40;	% number of theta angle subarrays
phdp=0;	% phi angle of theta pattern
phrp=pi/180*phdp;

%