% MATLAB script file for calculating far-field 
% patterns of reflector
% 
% PART d: equivalent surface currents
% previous m-files: po13a, po13b, po13c
%

Hs=zeros(Nr,3);	% initialize memory for arrays
Es=Hs;

for na=1:Na;		% iterate over source sample

  if(na/30==ceil(na/30));[na Na],end

  ut=norm01(rr-ones(Nr,1)*rs(na,:)); 
				% unit vect, source to field

  HscJ=-propnf01(rs(na,:),Js(na,:),rr,k0); % source H field
  EscJ=-Z0*cross01(ut,HscJ);	% source E field
  EscM=propnf01(rs(na,:),Ms(na,:),rr,k0); % source E field
  HscM=1/Z0*cross01(ut,EscM);	% source E field

  Hs=Hs+HscJ+HscM;	% sum contributions
  Es=Es+EscJ+EscM;

end

Jr=cross01(unr,Hs);		% eq electric current 
Mr=-cross01(unr,Es);		% eq magnetic current
Mn=Mr.*(dSr*ones(1,3));		% normalized current
Jn=Jr.*(dSr*ones(1,3)); 	% normalized current

Mrr=Mn;		% reradiation currents
Jrr=-Jn;

%