% MATLAB script file for calculating far-field 
% patterns of Cassegrain reflector 
%
% PART c: subreflector surface definition
%

z0=-sqrt(as^2+bs^2);		% z offset

Ner=ceil(Das/2/drsm);	% number of radial samples
der=Das/2/Ner;		% actual radial sampling increment

Ne=0;			% counter zero
for ner=1:Ner		% iterate over radius
  re(ner)=(ner-.5)*der;		% phi-sampling radii
  Nec(ner)=ceil(2*pi*re(ner)/dphsm);	
			% array of numbers of circ. samps 
  Ne=Ne+Nec(ner);	% total number of aperture samples
end

dep=2*pi./Nec;	
	% array of actual sample phi spacings at each radius

res=[];		% initialize arrays
DSe=[];
pheP=[];
une=[];
 
for ner=1:Ner		% iterate over radius
  if(ner/20==ceil(ner/20));[ner Ner],end
  phP=((1:Nec(ner))'-.5)*dep(ner);% phi primed angles array
  pheP=[pheP;phP];	% array of all phi primed angles
  zP=z0+as*sqrt(1+(re(ner)/bs).^2);	% z positions 
  res=[res;[re(ner)*[cos(phP) sin(phP)] zP*ones(size(phP))]];  
			% array of primed position vectors
  alphs=atan2(bs^2/as^2*(zP-z0),re(ner));% alpha angles
  une=[une;[[cos(phP) sin(phP)]*cos(alphs)...
			 -sin(alphs)*ones(size(phP))]];
   					% unit normals
  DSet=re(ner)*dep(ner)*der...
	*sqrt(1+(as/bs*re(ner))^2/(re(ner)^2+bs^2));
  DSe=[DSe;DSet*ones(size(phP))];% array of sample areas

end

ut2e=norm01(cross01(une,[1 0 0]));% second surf. tangent
ut1e=cross01(ut2e,une);		% first surface unit tangent 
					% position vectors
 
%