% MATLAB script file for calculating far-field 
% patterns of Cassegrain reflector 
%
% PART d: subreflector currents
%

Hse=zeros(Ne,3);	% initialize 
Ese=Hse;

for na=1:Ns;		% iterate over source sample
  if(na/50==ceil(na/50));[na Ns],end

  ute=norm01(res-ones(Ne,1)*rs(na,:)); 
			% unit vect, source to field

  HscJ=-propnf01(rs(na,:),Js(na,:),res,k0); % source H field
  EscJ=-Z0*cross01(ute,HscJ);	% source E field
  EscM=propnf01(rs(na,:),Ms(na,:),res,k0); % source E field
  HscM=1/Z0*cross01(ute,EscM);	% source E field

  Hse=Hse+HscJ+HscM;	% sum contributions
  Ese=Ese+EscJ+EscM;

end

Jre=cross01(une,Hse);		% eq electric current 
Mre=-cross01(une,Ese);		% eq magnetic current
Mne=Mre.*(DSe*ones(1,3));	% normalized current
Jne=Jre.*(DSe*ones(1,3)); 	% normalized current

Mrre=Mne;		% reradiation currents
Jrre=-Jne;

Mde=Mne;	% subreflector blockage currents
Jde=Jne;	% NOTE: these currents are negated twice:
		% 	once because the unit normal at the 
		%	subreflector surface points into
		% 	the surface instead of out of it for
		%	the purpose of obtaining the blockage
		% 	currents, twice for cancelling the 
		% 	feed fields there.
%