function [R2]=rotz01(R1,a)
%
% LD940118; function to rotate coordinates about the z axis
%
% This function rotates an array of coordinates in standard 
% format, R1, about the z axis by an angle, a (in radians) 
% to produce a standard-format array, R2, of the rotated 
% coordinates. The standard format is an N row by 3 column
% array with the rows being the individual points and the columns
% being the x, y, and z coordinates of the points.
%

M=[	cos(a) 	sin(a)	0
	-sin(a)	cos(a)	0	
	0	0	1	];

R2=R1*M.';

%